CShould be either VAX or AIX or UNIX or GFORTRAN
Cdefine(VAX)
Cdefine(AIX)
CFor open or close
C location of system-wide "SYMBOLS." file
CMoved from 1 (VAX) to * for compiler who checks(AIX)
Cdefine(DELETEF,'D')
CWas 3 for VMS
Cdefine(EXTEND,'A')
Cdefine(FORTRAN,'F')
C maximum field for integer strings
C must be highest lu for standard files
Cdefine(PRINTF,'P')
Cdefine(READ,'R')
Cdefine(READDELETE,'X')
Cdefine(READONLY,'R')
Cdefine(READWRITE,'W')
Cdefine(SAVEF,'S')
C Was 2 for VAX ?
Cdefine(WRITE,'W')
C definitions for macro processor
C put on a file named 'macsym'
C pushback buffer for ngetch and putbak
C max chars in a definition
C max depth of file inclusion
C max chars in all definitions
C max chars in a token
CModif NB
C number of characters per integer
C-----------------------------------------------------------------------
C definitions for the Ratfiv preprocessor
C put on a file named 'ratsym'
C max space for for reinit clauses
C function name size in dfunct
C max stack depth for parser
C max length of format in read, write, encode,decode
C max number of chars in string declares per module
C max stack for switch statement
C min number of cases to generate branch table
C reciprocal of density neccessary for branch table
C max chars in all definitions
C literal toggle flag
C number base flag
C ARCHIVE RATFIV.HDR              51   8-APR-82 09:48:44
C
C
C
C    RATFIV structured Fortran compiler
C    ==================================
C
C         Authors: Original by B. Kernighan and P. J. Plauger,
C                  with rewrites and enhancements by David Hanson and
C                  friends (U. of Arizona), Joe Sventek and Debbie
C                  Scherrer (Lawrence Berkely Laboratory), and
C                  William P. Wood, Jr. (Institute For Cancer Research).
C
C         Address: William P. Wood, Jr.
C                  Computer Center
C                  Institute For Cancer Research
C                  7701 Burholme Ave.
C                  Philadelphia, Pa. 19111
C                  (215) 728 2760
C
C         Version: 2.1
C
C         Date:   April 8, 1982
C
C
C
C      *******************************************************
C      *                                                     *
C      *      THIS SOFTWARE WAS DEVELOPED WITH SUPPORT       *
C      *      FROM THE NATIONAL INSTITUTES OF HEALTH:        *
C      *         NIH CA06927                                 *
C      *         NIH CA22780                                 *
C      *                                                     *
C      *      DIRECT INQUIRIES TO:                           *
C      *            COMPUTER CENTER                          *
C      *            THE INSTITUTE FOR CANCER RESEARCH        *
C      *            7701 BURHOLME AVENUE                     *
C      *            PHILADELPHIA, PENNSYLVANIA   19111       *
C      *                                                     *
C      *      NO WARRANTY OR REPRESENTATION, EXPRESS OR      *
C      *      IMPLIED, IS MADE WITH RESPECT TO THE           *
C      *      CORRECTNESS, COMPLETENESS, OR USEFULNESS       *
C      *      OF THIS SOFTWARE, NOR THAT USE OF THIS         *
C      *      SOFTWARE MIGHT NOT INFRINGE PRIVATELY          *
C      *      OWNED RIGHTS.                                  *
C      *                                                     *
C      *      NO LIABILITY IS ASSUMED WITH RESPECT TO        *
C      *      THE USE OF, OR FOR DAMAGES RESULTING FROM      *
C      *      THE USE OF THIS SOFTWARE                       *
C      *                                                     *
C      *******************************************************
C
C ARCHIVE ADDCHR.RAT              11  30-NOV-81 14:23:57
C addchr - put c in buf(bp) if it fits, increment bp
      SUBROUTINE ADDCHR(C, BUF, BP, MAXSIZ)
      INTEGER BP, MAXSIZ
      INTEGER C, BUF(*)
      IF (BP .GT. MAXSIZ) THEN
        CALL FATAL('string buffer overflow.')
      END IF
      BUF(BP) = C
      BP = BP + 1
      RETURN
      END
C ARCHIVE ADDSTR.RAT              10  30-NOV-81 14:23:57
C addstr - put s in buf(bp) by repeated calls to addchr
      SUBROUTINE ADDSTR(S, BUF, BP, MAXSIZ)
      INTEGER S(*), BUF(*)
      INTEGER BP, MAXSIZ
      INTEGER I
      I = 1
      DO WHILE (S(I) .NE. 0)
        CALL ADDCHR(S(I), BUF, BP, MAXSIZ)
2010    I = I + 1
      END DO
      RETURN
      END
C ARCHIVE BALPAR.RAT              34  30-NOV-81 14:23:57
C balpar - copy balanced paren string
      SUBROUTINE BALPAR
      INTEGER GETTOK
      INTEGER T, TOKEN(201)
CModif NB
      INTEGER CC
      INTEGER NLPAR
      IF (GETTOK(TOKEN, 201) .NE. 40) THEN
        CALL SYNERR('missing left paren.')
        RETURN
      END IF
      CALL OUTSTR(TOKEN)
      NLPAR = 1
2030  CONTINUE
        T = GETTOK(TOKEN, 201)
        IF (T .EQ. 59 .OR. T .EQ. -10 .OR. T .EQ. 93 .OR. T .EQ. 91 .OR.
     * (T .LT. 0 .AND. T .NE. 1)) THEN
          CALL PBSTR(TOKEN)
          GOTO 2050
        END IF
        IF (T .EQ. 10) THEN
C delete newlines
          TOKEN(1) = 0
        ELSE IF (T .EQ. 40) THEN
          NLPAR = NLPAR + 1
        ELSE IF (T .EQ. 41) THEN
          NLPAR = NLPAR - 1
C else nothing special
        END IF
        CALL OUTSTR(TOKEN)
        IF (T .EQ. 44) THEN
          CC = 32
          CALL OUTCH(CC)
        END IF
2040  IF (.NOT.(NLPAR .LE. 0)) GOTO 2030
2050  CONTINUE
      IF (NLPAR .NE. 0) THEN
        CALL SYNERR('missing parenthesis in condition.')
      END IF
      RETURN
      END
C ARCHIVE BRKNXT.RAT              35  30-NOV-81 14:23:57
C brknxt - generate code for break n and next n; n = 1 is default
      SUBROUTINE BRKNXT(SP, LEXTYP, LABVAL, TOKEN)
      INTEGER LABVAL(100), LEXTYP(100), SP, TOKEN
      INTEGER I, N, ALLDIG, CTOI
      INTEGER T, PTOKEN(201), GETTOK
      N = 0
      T = GETTOK(PTOKEN, 201)
      IF (ALLDIG(PTOKEN) .EQ. 1) THEN
C have break n or next n
        I = 1
        N = CTOI(PTOKEN, I) - 1
      ELSE IF (T .NE. 59) THEN
C default case
        CALL PBSTR(PTOKEN)
      END IF
      I = SP
      DO WHILE (I .GT. 0)
        IF (LEXTYP(I) .EQ. -64 .OR. LEXTYP(I) .EQ. -54 .OR. LEXTYP(I) .E
     *Q. -56 .OR. LEXTYP(I) .EQ. -61) THEN
          IF (N .GT. 0) THEN
            N = N - 1
C seek proper level
            GOTO 2070
          END IF
          IF (TOKEN .EQ. -52) THEN
C output break label
            LABVAL(I) = IABS(LABVAL(I))
            CALL OUTGO(LABVAL(I) + 10, 1)
          ELSE
            CALL OUTGO(IABS(LABVAL(I)), 1)
          END IF
          RETURN
        END IF
2070    I = I - 1
      END DO
      IF (TOKEN .EQ. -52) THEN
        CALL SYNERR('illegal break.')
      ELSE
        CALL SYNERR('illegal next.')
      END IF
      RETURN
      END
C ARCHIVE CASCOD.RAT              60   3-FEB-82 13:14:17
C switch statement - routines involved are cascod, caslab, swcode, swend, swvar
C cascod - generate code for case or default label
      SUBROUTINE CASCOD(LAB, TOKEN)
      INTEGER LAB, TOKEN, L, LB, UB, I, J, LABGEN
      INTEGER TOK(201), T, GETTOK, CASLAB
CModif
      INTEGER CC
C# Preprocessor common block used to hold switch info
C  Put on a file named 'cswtch'
C  Used only by ratfiv preprocessor
      COMMON/CSWTCH/SWTOP, SWLAST, SWSTAK(500)
C current switch entry; init = 0
      INTEGER SWTOP
C next available position; init = 1
      INTEGER SWLAST
C switch information
      INTEGER SWSTAK
      IF (SWTOP .LE. 0) THEN
        CALL SYNERR('illegal case or default.')
        RETURN
      END IF
C terminate previous case
      CALL OUTGO(LAB + 10, 1)
      L = LABGEN(1)
      IF (TOKEN .EQ. -72) THEN
C case n[,n]... : ...
2090    DO WHILE (CASLAB(LB, T) .NE. -10)
          UB = LB
          IF (T .EQ. 45) THEN
            JUNK = CASLAB(UB, T)
          END IF
          IF (LB .GT. UB) THEN
            CALL SYNERR('illegal range in case label.')
            UB = LB
          END IF
          IF (SWLAST+3 .GT. 500) THEN
            CALL FATAL('switch table overflow.')
          END IF
          I = SWTOP + 3
          DO WHILE (I .LT. SWLAST)
            IF (LB .LE. SWSTAK(I)) THEN
              GOTO 2130
            ELSE IF (LB .LE. SWSTAK(I+1)) THEN
              CALL SYNERR('duplicate case label.')
            END IF
2120        I = I + 3
          END DO
2130      CONTINUE
          IF (I .LT. SWLAST .AND. UB .GE. SWSTAK(I)) THEN
            CALL SYNERR('duplicate case label.')
          END IF
          J = SWLAST
          DO WHILE (J .GT. I)
C insert new entry
            SWSTAK(J + 2) = SWSTAK(J - 1)
2150        J = J - 1
          END DO
          SWSTAK(I) = LB
          SWSTAK(I + 1) = UB
          SWSTAK(I + 2) = L
          SWSTAK(SWTOP + 1) = SWSTAK(SWTOP + 1) + 1
          SWLAST = SWLAST + 3
          IF (T .NE. 44) THEN
            GOTO 2100
          END IF
        END DO
2100    CONTINUE
      ELSE
C default : ...
        T = GETTOK(TOK, 201)
        IF (SWSTAK(SWTOP+2) .NE. 0) THEN
          CALL SYNERR('multiple defaults in switch statement.')
        ELSE
          SWSTAK(SWTOP + 2) = L
        END IF
      END IF
      IF (T .EQ. -10) THEN
        CC =  - 10
        CALL PUTBAK(CC)
      ELSE IF (T .NE. 58) THEN
        CALL SYNERR('missing colon in case or default label.')
      END IF
      CALL INDEN( - (2))
      CALL OUTCON(L)
      CALL INDEN(2)
      RETURN
      END
C ARCHIVE CASLAB.RAT              33   2-FEB-82 09:58:24
C caslab - get one case label
      INTEGER FUNCTION CASLAB(N, T)
      INTEGER N, I, S
      INTEGER T, TOK(201), GETTOK, GTSKNL, ESC
      INTEGER CTOI, ALLDIG, ELENTH
      T = GTSKNL(TOK, 201)
      IF (T .EQ. -10) THEN
        CASLAB = T
        RETURN
      END IF
      IF (T .EQ. 45) THEN
        S =  - 1
      ELSE
        S =  + 1
      END IF
      IF (T .EQ. 45 .OR. T .EQ. 43) THEN
        T = GETTOK(TOK, 201)
      END IF
      IF (ALLDIG(TOK) .EQ. 1) THEN
        I = 1
        N = S*CTOI(TOK, I)
      ELSE IF (((T) .EQ. 39 .OR. (T) .EQ. 34) .AND. ELENTH(TOK) .EQ. 1) 
     *THEN
C character constant
        I = 1
        N = ESC(TOK, I)
      ELSE
        CALL SYNERR('invalid case label.')
        N = 0
      END IF
      T = GTSKNL(TOK, 201)
      CASLAB = T
      RETURN
      END
C ARCHIVE CHRDEF.RAT              47   3-FEB-82 13:21:34
C chrdef - return character defined by str, or def if str not defined
      INTEGER FUNCTION CHRDEF(STR, DEF)
      INTEGER STR(*), DEF, TOKEN(201), C, GETTOK, NQC
      INTEGER I1, I2, LOCDEF, CTOI
C Modif NB
      INTEGER CC
      IF (LOCDEF(STR, I1, I2, C) .EQ. 1) THEN
        CC = 47
        CALL PUTBAK(CC)
        CALL PBSTR(STR)
        C = GETTOK(TOKEN, 201)
        IF (((TOKEN(1)) .EQ. 39 .OR. (TOKEN(1)) .EQ. 34)) THEN
          I1 = 0
          I2 = 2
          DO WHILE (NQC(TOKEN,I2,TOKEN(1),C) .NE. 0)
            I1 = I1 + 1
2180        I2 = I2 + 1
          END DO
          IF (I1 .NE. 1) THEN
            GOTO 10
          END IF
          CHRDEF = TOKEN(2)
        ELSE
          I1 = 1
          IF (TOKEN(1) .EQ. 45) THEN
            C = GETTOK(TOKEN, 201)
            I2 =  - CTOI(TOKEN, I1)
          ELSE
            I2 = CTOI(TOKEN, I1)
          END IF
          IF (I1 .EQ. 1) THEN
            GOTO 10
          END IF
          CHRDEF = I2
          IF (CHRDEF .NE. I2) THEN
            GOTO 10
          END IF
        END IF
        IF (GETTOK(TOKEN, 201) .NE. 47) THEN
          CALL PBSTR(TOKEN)
          GOTO 10
        END IF
      ELSE
        CHRDEF = DEF
      END IF
      RETURN
10    CONTINUE
      CALL ERRLIN(STR)
      CALL SYNERR('bad definition for escaped character.')
      CHRDEF = (DEF)
      RETURN
      END
C ARCHIVE DFUNCT.RAT              16  30-NOV-81 14:23:58
C dfunct - define the current function name
      SUBROUTINE DFUNCT
C--------------------------------------------------------------------------
C# preprocessor common block to hold current function name
C put on a file named 'cfname'
C Used only by ratfiv preprocessor
      COMMON/CFNAME/FCNAME(35)
Ctext of current function name
      INTEGER FCNAME
      INTEGER T, GETTOK
      INTEGER FUNCT(9)
      DATA FUNCT(1)/102/,FUNCT(2)/117/,FUNCT(3)/110/,FUNCT(4)/99/,FUNCT(
     *5)/116/,FUNCT(6)/105/,FUNCT(7)/111/,FUNCT(8)/110/,FUNCT(9)/0/
      T = GETTOK(FCNAME, 35)
      CALL PBSTR(FCNAME)
      CALL OTHERC(FUNCT)
      IF (T .NE. 1) THEN
        CALL ERRLIN(FCNAME)
        CALL SYNERR('bad function name.')
        FCNAME(1) = 0
      END IF
      RETURN
      END
C ARCHIVE DOBASE.RAT              24  30-NOV-81 14:23:58
C dobase - convert number in base to decimal
      SUBROUTINE DOBASE(BASE, TOKEN, TOKSIZ, I)
      INTEGER BASE, TOKSIZ, I, N, CN, ITOC
      INTEGER TOKEN(*), C, NGETCH, CUPPER
      IF (BASE .GT. 1 .AND. BASE .LE. 36) THEN
C got one
        N = 0
        DO WHILE (.TRUE.)
          C = CUPPER(NGETCH(C))
          IF (C .GE. 65 .AND. C .LE. 90) THEN
            CN = C - 65 + 10
          ELSE IF (C .GE. 48 .AND. C .LE. 57) THEN
            CN = C - 48
          ELSE
            GOTO 2220
          END IF
          IF (CN .GE. BASE) THEN
            CALL SYNERR('digit inconsistent with base.')
          END IF
2210      N = BASE*N + CN
        END DO
2220    CONTINUE
        CALL PUTBAK(C)
        I = ITOC(N, TOKEN, TOKSIZ)
      ELSE
        CALL SYNERR('number base out of range.')
      END IF
      RETURN
      END
C ARCHIVE DOCODE.RAT              18  30-NOV-81 14:23:59
C docode - generate code for beginning of do
      SUBROUTINE DOCODE(LAB)
      INTEGER LABGEN
      INTEGER LAB
CModif NB
      INTEGER CC
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      INTEGER DOSTR(4)
      DATA DOSTR(1)/100/,DOSTR(2)/111/,DOSTR(3)/32/,DOSTR(4)/0/
      XFER = 0
      CALL OUTTAB
      CALL OUTSTR(DOSTR)
      LAB = LABGEN(2)
      CALL OUTNUM(LAB)
      CC = 32
      CALL OUTCH(CC)
      CALL EATUP
      CALL INDEN(2)
      LAB =  - LAB
      RETURN
      END
C ARCHIVE DOSTAT.RAT              10  30-NOV-81 14:23:59
C dostat - generate code for end of do statement
      SUBROUTINE DOSTAT(LAB)
      INTEGER LAB
      CALL INDEN( - (2))
      CALL OUTCON(IABS(LAB))
      IF (LAB .GT. 0) THEN
C break seen
        CALL OUTCON(LAB + 10)
      END IF
      RETURN
      END
C ARCHIVE EATUP.RAT               51  30-NOV-81 14:23:59
C eatup - process rest of statement
      SUBROUTINE EATUP
      INTEGER GETTOK, TYPE
      INTEGER PTOKEN(201), T, TOKEN(201)
C Modif NB
      INTEGER CC
      INTEGER NLPAR, LENGTH
C------------------------------------------------------------------
C# preprocessor common block to hold output characters
C put on a file named 'coutln'
C Used only by ratfiv preprocessor
      COMMON/COUTLN/OUTP, INDENT, OUTBUF(134)
C last position filled in outbuf; init = 0
      INTEGER OUTP
C current indent level (tab position)
      INTEGER INDENT
C output lines collected here
      INTEGER OUTBUF
C------------------------------------------------------------------
      NLPAR = 0
2230  CONTINUE
        T = GETTOK(TOKEN, 201)
        IF (T .EQ. 59 .OR. T .EQ. 10) THEN
          GOTO 2250
        ELSE IF (T .EQ. 93 .OR. T .EQ. 91 .OR. (T .LT. 0 .AND. T .NE. 1)
     *) THEN
          CALL PBSTR(TOKEN)
          GOTO 2250
        END IF
        IF (T .EQ. -10) THEN
          CALL SYNERR('unexpected EOF.')
          CALL PBSTR(TOKEN)
          GOTO 2250
        END IF
        IF (T .EQ. 44 .OR. T .EQ. 43 .OR. T .EQ. 45 .OR. T .EQ. 42 .OR. 
     *T .EQ. 40 .OR. T .EQ. 38 .OR. T .EQ. 124 .OR. T .EQ. 33 .OR. T .EQ
     *. 61 .OR. T .EQ. 126 .OR. T .EQ. 94 .OR. T .EQ. 62 .OR. T .EQ. 60 
     *.OR. T .EQ. 92) THEN
2260      DO WHILE (GETTOK(PTOKEN, 201) .EQ. 10)
          END DO
          CALL PBSTR(PTOKEN)
        END IF
        IF (T .EQ. 40) THEN
          NLPAR = NLPAR + 1
        ELSE IF (T .EQ. 41) THEN
          NLPAR = NLPAR - 1
        END IF
        IF (T .EQ. 43 .OR. T .EQ. 45 .OR. TOKEN(1) .EQ. 61) THEN
          CC = 32
          CALL OUTCH(CC)
          CALL OUTSTR(TOKEN)
          CALL OUTCH(CC)
        ELSE IF ((T .EQ. 1) .AND. (TYPE(OUTBUF(OUTP)) .EQ. 3)) THEN
          CC = 32
          CALL OUTCH(CC)
          CALL OUTSTR(TOKEN)
        ELSE IF (T .EQ. 44) THEN
          CALL OUTSTR(TOKEN)
          CC = 32
          CALL OUTCH(CC)
        ELSE
          CALL OUTSTR(TOKEN)
        END IF
2240  IF (.NOT.(NLPAR .LT. 0)) GOTO 2230
2250  CONTINUE
      IF (NLPAR .NE. 0) THEN
        CALL SYNERR('unbalanced parentheses.')
      END IF
      IF (T .NE. -51) THEN
        CALL OUTDON
      ELSE
        CC = 32
        CALL OUTCH(CC)
      END IF
      RETURN
      END
C ARCHIVE ELENTH.RAT              23   2-FEB-82 11:13:29
C elenth - remove quotes from buf, return escaped length of buf;
C two quotes in a row in a quoted string count as one literal quote
      INTEGER FUNCTION ELENTH(BUF)
      INTEGER BUF(*), C, Q
      INTEGER ESC, NQC
      INTEGER I, J
      IF (((BUF(1)) .EQ. 39 .OR. (BUF(1)) .EQ. 34) .AND. BUF(2) .NE. 0) 
     *THEN
        Q = BUF(1)
        J = 1
        I = 2
        DO WHILE (NQC(BUF,I,Q,C) .NE. 0)
          BUF(J) = C
          J = J + 1
2290      I = I + 1
        END DO
        BUF(J) = 0
      END IF
      J = 0
      I = 1
      DO WHILE (BUF(I) .NE. 0)
        C = ESC(BUF, I)
        J = J + 1
2320    I = I + 1
      END DO
      ELENTH = (J)
      RETURN
      END
C ARCHIVE ELSEF.RAT               26  30-NOV-81 14:24:00
C elsef - generate code for end of if before else
      SUBROUTINE ELSEF(ENDLAB, ELSLAB, ELSTYP)
      INTEGER ENDLAB, ELSLAB, ELSTYP
C Modif NB
      INTEGER CC
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      INTEGER ELSES(5)
      DATA ELSES(1)/101/,ELSES(2)/108/,ELSES(3)/115/,ELSES(4)/101/,ELSES
     *(5)/0/
      IF (F77) THEN
        CALL INDEN( - (2))
        CALL OUTTAB
        CALL OUTSTR(ELSES)
        IF (ELSTYP .EQ. -74) THEN
          CC = 32
          CALL OUTCH(CC)
        ELSE
          CALL OUTDON
        END IF
      ELSE
        CALL OUTGO(ENDLAB, 1)
        CALL INDEN( - (2))
        CALL OUTCON(ELSLAB)
      END IF
      IF (ELSTYP .EQ. -55) THEN
        CALL INDEN(2)
      END IF
      XFER = 0
      RETURN
      END
C ARCHIVE ESC.RAT                 34   3-FEB-82 23:21:38
C esc - map  array(i)  into escaped character if appropriate
      INTEGER FUNCTION ESC(ARRAY, I)
      INTEGER ARRAY(*), CUPPER, CHRDEF
      INTEGER I
      INTEGER EOSS(4)
      INTEGER NEWLS(8)
      DATA EOSS(1)/69/,EOSS(2)/79/,EOSS(3)/83/,EOSS(4)/0/
      DATA NEWLS(1)/78/,NEWLS(2)/69/,NEWLS(3)/87/,NEWLS(4)/76/,NEWLS(5)/
     *73/,NEWLS(6)/78/,NEWLS(7)/69/,NEWLS(8)/0/
      IF (ARRAY(I) .NE. 64) THEN
        ESC = ARRAY(I)
      ELSE IF (ARRAY(I+1) .EQ. 0) THEN
C ESCAPE not special at end
        ESC = 64
      ELSE
        I = I + 1
        I2340 = (CUPPER(ARRAY(I)))
        GOTO 2340
2360    CONTINUE
          ESC = 8
          GOTO 2350
2370    CONTINUE
          ESC = CHRDEF(EOSS, 0)
          GOTO 2350
2380    CONTINUE
          ESC = 12
          GOTO 2350
2390    CONTINUE
          ESC = 7
          GOTO 2350
2400    CONTINUE
          ESC = 10
          GOTO 2350
2410    CONTINUE
          ESC = CHRDEF(NEWLS, 10)
          GOTO 2350
2420    CONTINUE
          ESC = 13
          GOTO 2350
2430    CONTINUE
          ESC = 9
          GOTO 2350
2440    CONTINUE
          ESC = 11
          GOTO 2350
2450    CONTINUE
          ESC = 27
          GOTO 2350
2460    CONTINUE
          ESC = 0
          J = I
          DO WHILE (J .LT. I+3 .AND. (ARRAY(J) .GE. 48 .AND. ARRAY(J) .L
     *E. 55))
            ESC = 8*ESC + (ARRAY(J) - 48)
2480        J = J + 1
          END DO
          I = J - 1
          GOTO 2350
2500    CONTINUE
          ESC = ARRAY(I)
          GOTO 2350
2340    CONTINUE
        IF (I2340 .EQ. 36) GOTO 2450
        IF (I2340 .GE. 48 .AND. I2340 .LE. 55) GOTO 2460
        IF (I2340 .EQ. 66) GOTO 2360
        IF (I2340 .EQ. 69) GOTO 2370
        IF (I2340 .EQ. 70) GOTO 2380
        IF (I2340 .EQ. 71) GOTO 2390
        IF (I2340 .EQ. 76) GOTO 2400
        IF (I2340 .EQ. 78) GOTO 2410
        IF (I2340 .EQ. 82) GOTO 2420
        IF (I2340 .EQ. 84) GOTO 2430
        IF (I2340 .EQ. 86) GOTO 2440
        GOTO 2500
2350    CONTINUE
      END IF
      RETURN
      END
C ARCHIVE FCLAUS.RAT              33  30-NOV-81 14:24:00
C process "for" init or re-init clause
      SUBROUTINE FCLAUS
      INTEGER GETTOK
      INTEGER TOKEN(201), T
      INTEGER BRACK
      IF (GETTOK(TOKEN, 201) .EQ. 91) THEN
C { mother }
        BRACK = 1
      ELSE
        CALL PBSTR(TOKEN)
C other
        BRACK = 0
      END IF
2510  CONTINUE
        T = GETTOK(TOKEN, 201)
        IF (T .EQ. 93 .AND. BRACK .EQ. 1) THEN
          IF (GETTOK(TOKEN, 201) .NE. 59) THEN
            CALL SYNERR('invalid for clause.')
            CALL PBSTR(TOKEN)
          END IF
          GOTO 2530
        END IF
        IF (T .EQ. -10) THEN
          CALL PBSTR(TOKEN)
          CALL SYNERR('unexpected EOF.')
          GOTO 2530
        END IF
        IF (T .NE. 59) THEN
          CALL OTHERC(TOKEN)
        END IF
2520  IF (.NOT.(BRACK .EQ. 0)) GOTO 2510
2530  CONTINUE
      RETURN
      END
C ARCHIVE FORCOD.RAT             109  30-NOV-81 14:24:00
C forcod - beginning of for statement
      SUBROUTINE FORCOD(LAB)
      INTEGER GETTOK
      INTEGER T, TOKEN(201)
C Modif
      INTEGER CC
      INTEGER LENGTH, LABGEN
      INTEGER I, J, LAB, NLPAR
C .true. if condition part is empty
      LOGICAL EMPTYC
C--------------------------------------------------------------------------
C# preprocessor common block to hold info about 'for' statements
C put on a file named 'cfor'
C Used only by ratfiv preprocessor
      COMMON/CFOR/FORDEP, FORSTK(250)
C current depth of for statements
      INTEGER FORDEP
C stack of reinit strings
      INTEGER FORSTK
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
      INTEGER IFNOT(10)
      INTEGER WHILES(10)
      INTEGER TRUES(9)
      DATA IFNOT(1)/105/,IFNOT(2)/102/,IFNOT(3)/32/,IFNOT(4)/40/,IFNOT(5
     *)/46/,IFNOT(6)/110/,IFNOT(7)/111/,IFNOT(8)/116/,IFNOT(9)/46/,IFNOT
     *(10)/0/
      DATA WHILES(1)/100/,WHILES(2)/111/,WHILES(3)/32/,WHILES(4)/119/,WH
     *ILES(5)/104/,WHILES(6)/105/,WHILES(7)/108/,WHILES(8)/101/,WHILES(9
     *)/32/,WHILES(10)/0/
      DATA TRUES(1)/40/,TRUES(2)/46/,TRUES(3)/116/,TRUES(4)/114/,TRUES(5
     *)/117/,TRUES(6)/101/,TRUES(7)/46/,TRUES(8)/41/,TRUES(9)/0/
      EMPTYC = .FALSE.
      LAB = LABGEN(3)
      CALL OUTCON(0)
      IF (GETTOK(TOKEN, 201) .NE. 40) THEN
        CALL SYNERR('missing left paren.')
        RETURN
      END IF
      IF (GETTOK(TOKEN, 201) .NE. 59) THEN
C real init clause
        CALL PBSTR(TOKEN)
        CALL FCLAUS
      END IF
      IF (GETTOK(TOKEN, 201) .EQ. 59) THEN
C empty condition
        EMPTYC = .TRUE.
        IF (F77) THEN
          CALL OUTTAB
          CALL OUTSTR(WHILES)
          CALL OUTSTR(TRUES)
          CALL OUTDON
        ELSE
          CALL OUTCON(LAB)
        END IF
      ELSE
C non-empty condition
        CALL PBSTR(TOKEN)
        IF (F77) THEN
          CALL OUTTAB
          CALL OUTSTR(WHILES)
        ELSE
          CALL OUTNUM(LAB)
          CALL OUTTAB
          CALL OUTSTR(IFNOT)
        END IF
        CC = 40
        CALL OUTCH(CC)
        NLPAR = 0
2540    DO WHILE (NLPAR .GE. 0)
          T = GETTOK(TOKEN, 201)
          IF (T .EQ. 59) THEN
            GOTO 2550
          END IF
          IF (T .EQ. 40) THEN
            NLPAR = NLPAR + 1
          ELSE IF (T .EQ. 41) THEN
            NLPAR = NLPAR - 1
          END IF
          IF (T .EQ. -10) THEN
            CALL PBSTR(TOKEN)
            RETURN
          END IF
          IF (T .NE. 10) THEN
            CALL OUTSTR(TOKEN)
          END IF
        END DO
2550    CONTINUE
        CC = 41
        CALL OUTCH(CC)
        IF (F77) THEN
          CALL OUTDON
        ELSE
          CC = 41
          CALL OUTCH(CC)
          CC = 32
          CALL OUTCH(CC)
          CALL OUTGO(LAB + 20, 0)
        END IF
        IF (NLPAR .LT. 0) THEN
          CALL SYNERR('invalid for clause.')
        END IF
      END IF
C stack reinit clause
      FORDEP = FORDEP + 1
      J = 1
      I = 1
      DO WHILE (I .LT. FORDEP)
C find end
        J = J + LENGTH(FORSTK(J)) + 1
2570    I = I + 1
      END DO
C null, in case no reinit
      FORSTK(J) = 0
      NLPAR = 0
2590  DO WHILE (NLPAR .GE. 0)
        T = GETTOK(TOKEN, 201)
        IF (T .EQ. 40) THEN
          NLPAR = NLPAR + 1
        ELSE IF (T .EQ. 41) THEN
          NLPAR = NLPAR - 1
        END IF
        IF (T .EQ. -10) THEN
          CALL PBSTR(TOKEN)
          GOTO 2600
        END IF
        IF (NLPAR .GE. 0 .AND. T .NE. 10) THEN
          IF (T .EQ. 43 .OR. T .EQ. 45 .OR. TOKEN(1) .EQ. 61) THEN
            TOKEN(1) = 32
            TOKEN(2) = T
            TOKEN(3) = 32
            TOKEN(4) = 0
          ELSE IF (T .EQ. 44) THEN
            TOKEN(2) = 32
            TOKEN(3) = 0
          END IF
          IF (J+LENGTH(TOKEN) .GE. 250) THEN
            CALL FATAL('for clause too long.')
          END IF
          CALL SCOPY(TOKEN, 1, FORSTK, J)
          J = J + LENGTH(TOKEN)
        END IF
      END DO
2600  CONTINUE
      CALL INDEN(2)
C label for next's
      LAB = LAB + 10
      IF (F77 .OR. EMPTYC) THEN
        LAB =  - LAB
      END IF
      RETURN
      END
C ARCHIVE FORMA.RAT               81  30-NOV-81 14:24:00
C forma - output format statement for write, read, encode, and decode
      SUBROUTINE FORMA(TOKEN)
      INTEGER TOKEN(*), T, TOK(201), FORST(600)
      INTEGER GETTOK, GTSKNL
C Modif NB
      INTEGER CC
      INTEGER J, LENGTH, LABGEN, LAB
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
      INTEGER FORM(7)
      DATA FORM(1)/102/,FORM(2)/111/,FORM(3)/114/,FORM(4)/109/,FORM(5)/9
     *7/,FORM(6)/116/,FORM(7)/0/
      CALL OUTTAB
      CALL OUTSTR(TOKEN)
      T = GETTOK(TOK, 201)
      IF (T .NE. 40) THEN
        CALL PBSTR(TOK)
        CALL EATUP
        RETURN
      END IF
      CALL OUTSTR(TOK)
      CALL SKPOUT(T)
      IF (T .EQ. -10) THEN
        RETURN
      END IF
      IF (T .EQ. 41) THEN
        CALL EATUP
        RETURN
      END IF
      T = GTSKNL(TOK, 201)
      IF (T .NE. 40) THEN
        CALL PBSTR(TOK)
2610    CONTINUE
          CALL SKPOUT(T)
          IF (T .EQ. -10) THEN
            RETURN
          END IF
2620    IF (.NOT.(T .EQ. 41)) GOTO 2610
        CALL EATUP
      ELSE
        LAB = LABGEN(1)
        CALL OUTNUM(LAB)
        J = 1
        FORST(1) = 0
        NLPAR = 0
Cdon't convert < and > to .lt. and .gt.
        INFORM = .TRUE.
2640    CONTINUE
          T = GETTOK(TOK, 201)
          IF (T .EQ. -10) THEN
            CALL PBSTR(TOK)
            CALL SYNERR('unexpected EOF.')
            INFORM = .FALSE.
            RETURN
          END IF
          IF (T .EQ. 40) THEN
            NLPAR = NLPAR + 1
          ELSE IF (T .EQ. 41) THEN
            NLPAR = NLPAR - 1
          END IF
          IF (NLPAR .GE. 0 .AND. T .NE. 10) THEN
            IF (J+LENGTH(TOK) .GE. 600) THEN
              CALL SYNERR('format too long.')
              GOTO 2660
            END IF
            CALL SCOPY(TOK, 1, FORST, J)
            J = J + LENGTH(TOK)
          END IF
2650    IF (.NOT.(NLPAR .LT. 0)) GOTO 2640
2660    CONTINUE
        INFORM = .FALSE.
2670    CONTINUE
          CALL SKPOUT(T)
          IF (T .EQ. -10) THEN
            RETURN
          END IF
2680    IF (.NOT.(T .EQ. 41)) GOTO 2670
        CALL EATUP
        CALL INDEN(2)
        CALL OUTNUM(LAB)
        CALL OUTTAB
        CALL OUTSTR(FORM)
        CC = 40
        CALL OUTCH(CC)
        CALL OUTSTR(FORST)
        CC = 41
        CALL OUTCH(CC)
        CALL OUTDON
        CALL INDEN( - (2))
      END IF
      RETURN
      END
C ARCHIVE FORS.RAT                34  30-NOV-81 14:24:01
C fors - process end of for statement
      SUBROUTINE FORS(LAB)
      INTEGER LENGTH
      INTEGER I, J, LAB
CModif NB
      INTEGER CC
C--------------------------------------------------------------------------
C# preprocessor common block to hold info about 'for' statements
C put on a file named 'cfor'
C Used only by ratfiv preprocessor
      COMMON/CFOR/FORDEP, FORSTK(250)
C current depth of for statements
      INTEGER FORDEP
C stack of reinit strings
      INTEGER FORSTK
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
      INTEGER ENDDOS(7)
      DATA ENDDOS(1)/101/,ENDDOS(2)/110/,ENDDOS(3)/100/,ENDDOS(4)/32/,EN
     *DDOS(5)/100/,ENDDOS(6)/111/,ENDDOS(7)/0/
      XFER = 0
      J = 1
      I = 1
      DO WHILE (I .LT. FORDEP)
        J = J + LENGTH(FORSTK(J)) + 1
2710    I = I + 1
      END DO
      CALL OUTNUM(IABS(LAB))
      IF (LENGTH(FORSTK(J)) .GT. 0) THEN
        CC = 59
        CALL PUTBAK(CC)
        CALL PBSTR(FORSTK(J))
        CALL FCLAUS
      ELSE IF (F77) THEN
        CALL OUTCON(0)
      END IF
      CALL INDEN( - (2))
      IF (F77) THEN
        CALL OUTTAB
        CALL OUTSTR(ENDDOS)
        CALL OUTDON
      ELSE
        CALL OUTGO(IABS(LAB) - 10, 1)
      END IF
      IF (LAB .GT. 0) THEN
        CALL OUTCON(LAB + 10)
      END IF
      FORDEP = FORDEP - 1
      RETURN
      END
C ARCHIVE GETTOK.RAT              10  30-NOV-81 14:24:01
C gettok - get token after processing by deftok
      INTEGER FUNCTION GETTOK(TOKEN, TOKSIZ)
      INTEGER TOKEN(*), DEFTOK
      INTEGER TOKSIZ
2730  CONTINUE
        GETTOK = DEFTOK(TOKEN, TOKSIZ)
2740  IF (.NOT.(GETTOK .NE. 32 .AND. GETTOK .NE. 9)) GOTO 2730
      RETURN
      END
C ARCHIVE GTOKENR.RAT            121  15-DEC-81 23:44:58
C gtoken - get token for Ratfiv
      INTEGER FUNCTION GTOKEN(TOKEN, TOKSIZ)
      INTEGER NGETCH, TYPE
      INTEGER I, TOKSIZ, J, CTOI, ALLDIG
      INTEGER C, TOKEN(*)
C Modif NB
      INTEGER CC
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      I = 1
      DO WHILE (I .LE. TOKSIZ)
        GTOKEN = TYPE(NGETCH(TOKEN(I)))
        IF (GTOKEN .NE. 3 .AND. GTOKEN .NE. 2 .AND. GTOKEN .NE. 95 .AND.
     * GTOKEN .NE. 36) THEN
          GOTO 2780
        END IF
2770    I = I + 1
      END DO
2780  CONTINUE
      C = TOKEN(1)
      IF (I .GT. 1) THEN
C some alpha seen
        GTOKEN = 1
        IF (I .GT. TOKSIZ) THEN
          I = TOKSIZ - 1
          CALL SYNERR('token too long.')
        ELSE
          C = TOKEN(I)
          TOKEN(I) = 0
          I = I - 1
          IF (C .EQ. 37) THEN
C check for base other than 10
            IF (ALLDIG(TOKEN) .EQ. 1) THEN
              J = 1
              CALL DOBASE(CTOI(TOKEN, J), TOKEN, TOKSIZ, I)
              IF (TOKEN(1) .EQ. 45) THEN
                GTOKEN = 45
                I = 1
                CALL PBSTR(TOKEN(2))
              END IF
            ELSE
              CC = 37
              CALL PUTBAK(CC)
            END IF
          ELSE
            CALL PUTBAK(C)
          END IF
        END IF
      ELSE IF (((C) .EQ. 39 .OR. (C) .EQ. 34) .OR. C .EQ. 96) THEN
C Accented strings are passed through as literal strings, with the accents
C being stripped off of the output. Any characters (except EOF) may appear
C within accents.
C Two occurrences of the initial quote character (', ", or `) within a string
C in a row are interpreted as a single literal occurrence of that character.
C Unbalanced occurrences of ' or " are allowed on a line and are passed
C through as themselves.
        GTOKEN = C
        I = 2
        DO WHILE (I .LT. TOKSIZ)
          IF (NGETCH(TOKEN(I)) .EQ. C) THEN
            IF (NGETCH(TOKEN(I+1)) .NE. C) THEN
              CALL PUTBAK(TOKEN(I + 1))
              GOTO 2810
            ELSE
              I = I + 1
            END IF
          ELSE IF (C .EQ. 96 .AND. TOKEN(I) .EQ. -10) THEN
            CALL SYNERR('EOF in literal string.')
            TOKEN(I) = 96
            CC =  - 10
            CALL PUTBAK(CC)
            GOTO 2810
          ELSE IF (C .NE. 96 .AND. (TOKEN(I) .EQ. 10 .OR. TOKEN(I) .EQ. 
     *-10)) THEN
            IF (TOKEN(I) .EQ. -10) THEN
              CALL SYNERR('EOF in quoted string.')
C allow unbalanced quote on line
            END IF
            DO WHILE (I .GT. 1 .AND. TOKEN(I) .NE. C)
              CALL PUTBAK(TOKEN(I))
2830          I = I - 1
            END DO
            IF (I .GT. 1) THEN
              CALL PUTBAK(C)
              I = I - 1
            END IF
            GOTO 2810
          END IF
2800      I = I + 1
        END DO
2810    CONTINUE
        IF (I .GE. TOKSIZ) THEN
          IF (C .EQ. 96) THEN
            CALL SYNERR('missing accent.')
          ELSE
            CALL SYNERR('missing quote.')
          END IF
          CALL SYNERR('token too long.')
          IF (TOKEN(I-1) .EQ. C) THEN
            I = I - 2
          ELSE
            I = I - 1
          END IF
          TOKEN(I) = C
        END IF
      ELSE IF (CP .EQ. 0) THEN
C not in a macro?
        IF (C .EQ. 123) THEN
C allow { for [
          TOKEN(1) = 91
          GTOKEN = 91
        ELSE IF (C .EQ. 125) THEN
C allow } for ]
          TOKEN(1) = 93
          GTOKEN = 93
        ELSE IF (C .EQ. 35) THEN
C output comments
          CALL OUTCOM(TOKEN)
          TOKEN(1) = 10
          GTOKEN = 10
        ELSE IF (C .EQ. 62 .OR. C .EQ. 60 .OR. C .EQ. 126 .OR. C .EQ. 33
     * .OR. C .EQ. 94 .OR. C .EQ. 92 .OR. C .EQ. 61 .OR. C .EQ. 38 .OR. 
     *C .EQ. 124) THEN
          IF (TOKSIZ .LT. 11) THEN
            CALL SYNERR('gtoken: shouldn''t happen.')
          ELSE
            CALL RELATE(TOKEN, I)
          END IF
        END IF
      END IF
      TOKEN(I + 1) = 0
      RETURN
      END
C ARCHIVE GTSKNL.RAT              10  30-NOV-81 14:24:02
C gtsknl - get next token, skip newlines
      INTEGER FUNCTION GTSKNL(TOKEN, TOKSIZ)
      INTEGER TOKEN(*), GETTOK
      INTEGER TOKSIZ
2850  CONTINUE
        GTSKNL = GETTOK(TOKEN, TOKSIZ)
2860  IF (.NOT.(GTSKNL .NE. 10)) GOTO 2850
      RETURN
      END
C ARCHIVE IFCODE.RAT              25  30-NOV-81 14:24:02
C ifcode - generate initial code for if
      SUBROUTINE IFCODE(LAB)
      INTEGER LABGEN
      INTEGER LAB
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      INTEGER IFS(4)
      INTEGER THENS(6)
      DATA IFS(1)/105/,IFS(2)/102/,IFS(3)/32/,IFS(4)/0/
      DATA THENS(1)/32/,THENS(2)/116/,THENS(3)/104/,THENS(4)/101/,THENS(
     *5)/110/,THENS(6)/0/
      XFER = 0
      IF (F77) THEN
        CALL OUTTAB
        CALL OUTSTR(IFS)
        CALL BALPAR
        CALL OUTSTR(THENS)
        CALL OUTDON
      ELSE
        LAB = LABGEN(2)
        CALL IFGO(LAB)
      END IF
      CALL INDEN(2)
      RETURN
      END
C ARCHIVE IFGO.RAT                13  30-NOV-81 14:24:02
C ifgo - generate 'if (.not.(...)) goto lab'
      SUBROUTINE IFGO(LAB)
      INTEGER LAB
C Modif
      INTEGER CC
      INTEGER IFNOT(10)
      DATA IFNOT(1)/105/,IFNOT(2)/102/,IFNOT(3)/32/,IFNOT(4)/40/,IFNOT(5
     *)/46/,IFNOT(6)/110/,IFNOT(7)/111/,IFNOT(8)/116/,IFNOT(9)/46/,IFNOT
     *(10)/0/
C get to column 7
      CALL OUTTAB
C 'if (.not.'
      CALL OUTSTR(IFNOT)
C collect and output condition
      CALL BALPAR
      CC = 41
C ')'
      CALL OUTCH(CC)
      CC = 32
      CALL OUTCH(CC)
C ' goto lab'
      CALL OUTGO(LAB, 0)
      RETURN
      END
C ARCHIVE IFS.RAT                 24  30-NOV-81 14:24:02
C ifs - generate code for end of if
      SUBROUTINE IFS(SP, LEXTYP, LABVAL)
      INTEGER SP, LEXTYP(100), LABVAL(100)
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      INTEGER ENDIFS(7)
      DATA ENDIFS(1)/101/,ENDIFS(2)/110/,ENDIFS(3)/100/,ENDIFS(4)/32/,EN
     *DIFS(5)/105/,ENDIFS(6)/102/,ENDIFS(7)/0/
      XFER = 0
      CALL INDEN( - (2))
      IF (F77) THEN
        CALL OUTTAB
        CALL OUTSTR(ENDIFS)
        CALL OUTDON
      ELSE
        I2880 = (LEXTYP(SP))
        GOTO 2880
2900    CONTINUE
          CALL OUTCON(LABVAL(SP))
          GOTO 2890
2910    CONTINUE
          CALL OUTCON(LABVAL(SP - 1))
          GOTO 2890
2920    CONTINUE
          CALL OUTCON(LABVAL(SP))
          CALL OUTCON(LABVAL(SP - 1))
          GOTO 2890
2880    CONTINUE
        IF (I2880 .EQ. -74) GOTO 2920
        IF (I2880 .EQ. -57) GOTO 2900
        IF (I2880 .EQ. -55) GOTO 2910
2890    CONTINUE
      END IF
      SP = SP - 1
      RETURN
      END
C ARCHIVE INDEN.RAT                8  30-NOV-81 14:24:03
C inden - indent or outdent the tab position
      SUBROUTINE INDEN(IND)
      INTEGER IND
C------------------------------------------------------------------
C# preprocessor common block to hold output characters
C put on a file named 'coutln'
C Used only by ratfiv preprocessor
      COMMON/COUTLN/OUTP, INDENT, OUTBUF(134)
C last position filled in outbuf; init = 0
      INTEGER OUTP
C current indent level (tab position)
      INTEGER INDENT
C output lines collected here
      INTEGER OUTBUF
C------------------------------------------------------------------
      INDENT = MAX0(0, INDENT + IND)
      RETURN
      END
C ARCHIVE INIRAT.RAT              97  30-NOV-81 14:24:03
C inirat - initialize table and install keywords
      SUBROUTINE INIRAT
      INTEGER SET
      INTEGER SDEFIN(7), VDEFIN(2)
      INTEGER SINCLU(8), VINCLU(2)
      INTEGER SFUNCT(9), VFUNCT(2)
      INTEGER SDO(3), VDO(2)
      INTEGER SIF(3), VIF(2)
      INTEGER SELSE(5), VELSE(2)
      INTEGER SWHILE(6), VWHILE(2)
      INTEGER SFOR(4), VFOR(2)
      INTEGER SREPEA(7), VREPEA(2)
      INTEGER SUNTIL(6), VUNTIL(2)
      INTEGER SNEXT(5), VNEXT(2)
      INTEGER SBREAK(6), VBREAK(2)
      INTEGER SRETUR(7), VRETUR(2)
      INTEGER SREAD(5), VREAD(2)
      INTEGER SWRITE(6), VWRITE(2)
      INTEGER SENCOD(7), VENCOD(2)
      INTEGER SDECOD(7), VDECOD(2)
      INTEGER SFORMA(7), VFORMA(2)
      INTEGER SSTRNG(7), VSTRNG(2)
      INTEGER SSWTCH(7), VSWTCH(2)
      INTEGER SCASE(5), VCASE(2)
      INTEGER SDEFAL(8), VDEFAL(2)
      DATA SDEFIN/100, 101, 102, 105, 110, 101, 0/, VDEFIN/ - 20, 0/
      DATA SINCLU/105, 110, 99, 108, 117, 100, 101, 0/, VINCLU/ - 50, 0/
      DATA SFUNCT/102, 117, 110, 99, 116, 105, 111, 110, 0/, VFUNCT/ - 5
     *1, 0/
      DATA SDO/100, 111, 0/, VDO/ - 54, 0/
      DATA SIF/105, 102, 0/, VIF/ - 57, 0/
      DATA SELSE/101, 108, 115, 101, 0/, VELSE/ - 55, 0/
      DATA SWHILE/119, 104, 105, 108, 101, 0/, VWHILE/ - 64, 0/
      DATA SFOR/102, 111, 114, 0/, VFOR/ - 56, 0/
      DATA SREPEA/114, 101, 112, 101, 97, 116, 0/, VREPEA/ - 61, 0/
      DATA SUNTIL/117, 110, 116, 105, 108, 0/, VUNTIL/ - 63, 0/
      DATA SNEXT/110, 101, 120, 116, 0/, VNEXT/ - 59, 0/
      DATA SBREAK/98, 114, 101, 97, 107, 0/, VBREAK/ - 52, 0/
      DATA SRETUR/114, 101, 116, 117, 114, 110, 0/, VRETUR/ - 62, 0/
      DATA SREAD/114, 101, 97, 100, 0/, VREAD/ - 66, 0/
      DATA SWRITE/119, 114, 105, 116, 101, 0/, VWRITE/ - 65, 0/
      DATA SENCOD/101, 110, 99, 111, 100, 101, 0/, VENCOD/ - 67, 0/
      DATA SDECOD/100, 101, 99, 111, 100, 101, 0/, VDECOD/ - 68, 0/
      DATA SFORMA/102, 111, 114, 109, 97, 116, 0/, VFORMA/ - 69, 0/
      DATA SSTRNG/115, 116, 114, 105, 110, 103, 0/, VSTRNG/ - 70, 0/
      DATA SSWTCH/115, 119, 105, 116, 99, 104, 0/, VSWTCH/ - 71, 0/
      DATA SCASE/99, 97, 115, 101, 0/, VCASE/ - 72, 0/
      DATA SDEFAL/100, 101, 102, 97, 117, 108, 116, 0/, VDEFAL/ - 73, 0/
      CALL INSUPL(SDEFIN, VDEFIN, SET(SET(SET(0, 10), 11), 1))
      CALL INSUPL(SINCLU, VINCLU, 0)
      CALL INSUPL(SFUNCT, VFUNCT, 0)
      CALL INSUPL(SDO, VDO, 0)
      CALL INSUPL(SIF, VIF, 0)
      CALL INSUPL(SELSE, VELSE, 0)
      CALL INSUPL(SWHILE, VWHILE, 0)
      CALL INSUPL(SFOR, VFOR, 0)
      CALL INSUPL(SREPEA, VREPEA, 0)
      CALL INSUPL(SUNTIL, VUNTIL, 0)
      CALL INSUPL(SNEXT, VNEXT, 0)
      CALL INSUPL(SBREAK, VBREAK, 0)
      CALL INSUPL(SRETUR, VRETUR, 0)
      CALL INSUPL(SREAD, VREAD, 0)
      CALL INSUPL(SWRITE, VWRITE, 0)
      CALL INSUPL(SENCOD, VENCOD, 0)
      CALL INSUPL(SDECOD, VDECOD, 0)
      CALL INSUPL(SFORMA, VFORMA, 0)
      CALL INSUPL(SSTRNG, VSTRNG, 0)
      CALL INSUPL(SSWTCH, VSWTCH, 0)
      CALL INSUPL(SCASE, VCASE, 0)
      CALL INSUPL(SDEFAL, VDEFAL, 0)
      RETURN
      END
C ARCHIVE LABELC.RAT              15  30-NOV-81 14:24:03
C labelc - output statement number
      SUBROUTINE LABELC(LEXSTR)
      INTEGER LEXSTR(*)
      INTEGER LENGTH, I
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
C can't suppress goto's now
      XFER = 0
      I = LENGTH(LEXSTR)
      IF (LEXSTR(I) .EQ. 48) THEN
        IF (I .GT. 4 .OR. (LEXSTR(1) .NE. 49 .AND. I .EQ. 4)) THEN
          CALL SYNERR('warning: possible label conflict.')
        END IF
      END IF
      CALL OUTSTR(LEXSTR)
      CALL OUTTAB
      RETURN
      END
C ARCHIVE LABGEN.RAT               9  30-NOV-81 14:24:03
C labgen - generate  n  consecutive labels, return first one
      INTEGER FUNCTION LABGEN(N)
      INTEGER N
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      LABGEN = LABEL
      LABEL = LABEL + N*10
      RETURN
      END
C ARCHIVE LEX.RAT                 20  30-NOV-81 14:24:04
C lex - return lexical type of token
      INTEGER FUNCTION LEX(LEXSTR)
      INTEGER GETTOK
      INTEGER LEXSTR(201)
      INTEGER ALLDIG
2930  DO WHILE (GETTOK(LEXSTR, 201) .EQ. 10)
      END DO
      LEX = LEXSTR(1)
      IF (LEX .LT. 0 .OR. LEX .EQ. -10 .OR. LEX .EQ. 59 .OR. LEX .EQ. 91
     * .OR. LEX .EQ. 93) THEN
      ELSE IF (ALLDIG(LEXSTR) .EQ. 1) THEN
        LEX =  - 53
      ELSE IF (LEX .EQ. 37) THEN
        LEX =  - 58
      ELSE
        LEX =  - 60
      END IF
      RETURN
      END
C ARCHIVE LITRAL.RAT              37   1-DEC-81 11:18:38
C litral - process literal Fortran lines
      SUBROUTINE LITRAL
      INTEGER NGETCH, C
C Modif
      INTEGER CC
      INTEGER NB
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
C Finish off any left-over characters
      CALL OUTDON
      XFER = 0
      NB = 0
      DO WHILE (NGETCH(C) .EQ. 32)
2960    NB = NB + 1
      END DO
      IF (C .NE. 10) THEN
C literal on this line only
        DO WHILE (NB .GT. 0)
          CC = 32
          CALL PUTCH(CC, 6)
2990      NB = NB - 1
        END DO
3010    CONTINUE
          IF (C .EQ. -10) THEN
            GOTO 10
          END IF
          CALL PUTCH(C, 6)
3020    IF (.NOT.(NGETCH(C) .EQ. 10)) GOTO 3010
        CC = 10
        CALL PUTCH(CC, 6)
C loop until matching toggle found
      ELSE
3040    DO WHILE (NGETCH(C) .NE. 37)
3060      CONTINUE
            IF (C .EQ. -10) THEN
              GOTO 10
            END IF
            CALL PUTCH(C, 6)
3070      IF (.NOT.(NGETCH(C) .EQ. 10)) GOTO 3060
          CC = 10
          CALL PUTCH(CC, 6)
        END DO
      END IF
      RETURN
10    CC =  - 10
      CALL PUTBAK(CC)
      CALL SYNERR('EOF in literal fortran code.')
      RETURN
      END
C ARCHIVE NQC.RAT                 13  30-NOV-81 14:24:04
C nqc - get next character from quoted character string
      INTEGER FUNCTION NQC(LIN, I, Q, C)
      INTEGER LIN(*), Q, C
      INTEGER I
      C = LIN(I)
      IF (C .EQ. Q) THEN
        IF (LIN(I+1) .EQ. Q) THEN
          I = I + 1
        ELSE
          C = 0
        END IF
      END IF
      NQC = (C)
      RETURN
      END
C ARCHIVE OTHERC.RAT              11  30-NOV-81 14:24:04
C otherc - output ordinary Fortran statement
      SUBROUTINE OTHERC(LEXSTR)
      INTEGER LEXSTR(*)
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      XFER = 0
      CALL OUTTAB
      CALL OUTSTR(LEXSTR)
      CALL EATUP
      RETURN
      END
C ARCHIVE OUTCH.RAT               18  30-NOV-81 14:24:05
C outch - put one character into output buffer
      SUBROUTINE OUTCH(C)
      INTEGER C
      INTEGER I
C------------------------------------------------------------------
C# preprocessor common block to hold output characters
C put on a file named 'coutln'
C Used only by ratfiv preprocessor
      COMMON/COUTLN/OUTP, INDENT, OUTBUF(134)
C last position filled in outbuf; init = 0
      INTEGER OUTP
C current indent level (tab position)
      INTEGER INDENT
C output lines collected here
      INTEGER OUTBUF
C------------------------------------------------------------------
      IF (OUTP .GE. 72) THEN
C continuation card
        CALL OUTDON
        I = 1
        DO WHILE (I .LT. 6)
          OUTBUF(I) = 32
3100      I = I + 1
        END DO
        OUTBUF(6) = 42
        OUTP = 6
      END IF
      OUTP = OUTP + 1
      OUTBUF(OUTP) = C
      RETURN
      END
C ARCHIVE OUTCOM.RAT              24  30-NOV-81 14:24:05
C outcom - output comments
      SUBROUTINE OUTCOM(TOKEN)
      INTEGER TOKEN(1), NGETCH
CModif
      INTEGER CC
      INTEGER J
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
C------------------------------------------------------------------
C# preprocessor common block to hold output characters
C put on a file named 'coutln'
C Used only by ratfiv preprocessor
      COMMON/COUTLN/OUTP, INDENT, OUTBUF(134)
C last position filled in outbuf; init = 0
      INTEGER OUTP
C current indent level (tab position)
      INTEGER INDENT
C output lines collected here
      INTEGER OUTBUF
C------------------------------------------------------------------
      IF (DEFSTK(DEFCNT) .AND. (OUTP .LT. 6 .OR. OUTBUF(6) .EQ. 32)) THE
     *N
        CC = 67
        CALL PUTCH(CC, 6)
        J = 2
        DO WHILE (NGETCH(TOKEN(1)) .NE. 10)
          IF (J .GT. 80) THEN
            CC = 10
            CALL PUTCH(CC, 6)
            CC = 67
            CALL PUTCH(CC, 6)
            J = 2
          END IF
          CALL PUTCH(TOKEN(1), 6)
3130      J = J + 1
        END DO
        CC = 10
        CALL PUTCH(CC, 6)
      ELSE
3150    DO WHILE (NGETCH(TOKEN(1)) .NE. 10)
        END DO
      END IF
      RETURN
      END
C ARCHIVE OUTCON.RAT              17  30-NOV-81 14:24:05
C outcon - output 'n   continue'
      SUBROUTINE OUTCON(N)
      INTEGER N
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
C------------------------------------------------------------------
C# preprocessor common block to hold output characters
C put on a file named 'coutln'
C Used only by ratfiv preprocessor
      COMMON/COUTLN/OUTP, INDENT, OUTBUF(134)
C last position filled in outbuf; init = 0
      INTEGER OUTP
C current indent level (tab position)
      INTEGER INDENT
C output lines collected here
      INTEGER OUTBUF
C------------------------------------------------------------------
      INTEGER CONTIN(9)
      DATA CONTIN(1)/99/,CONTIN(2)/111/,CONTIN(3)/110/,CONTIN(4)/116/,CO
     *NTIN(5)/105/,CONTIN(6)/110/,CONTIN(7)/117/,CONTIN(8)/101/,CONTIN(9
     *)/0/
      XFER = 0
      IF (N .LE. 0 .AND. OUTP .EQ. 0) THEN
C don't need unlabeled continues
        RETURN
      END IF
      IF (N .GT. 0) THEN
        CALL OUTNUM(N)
      END IF
      CALL OUTTAB
      CALL OUTSTR(CONTIN)
      CALL OUTDON
      RETURN
      END
C ARCHIVE OUTDEF.RAT              22   3-FEB-82 13:20:06
C outdef - put out defined meaning of str, or defstr if str not defined
      SUBROUTINE OUTDEF(STR, DEFSTR)
      INTEGER STR(*), DEFSTR(*), TOKEN(201), C, GETTOK
CModif NB
      INTEGER CC
      INTEGER JUNK1, JUNK2, LOCDEF
      IF (LOCDEF(STR, JUNK1, JUNK2, C) .EQ. 1) THEN
        CC = 47
        CALL PUTBAK(CC)
        CALL PBSTR(STR)
3170    DO WHILE (GETTOK(TOKEN, 201) .NE. 47)
          IF (TOKEN(1) .EQ. -10) THEN
            CALL PBSTR(TOKEN)
            RETURN
          END IF
          CALL OUTSTR(TOKEN)
        END DO
      ELSE
        CALL OUTSTR(DEFSTR)
      END IF
      RETURN
      END
C ARCHIVE OUTDON.RAT              12   1-DEC-81 10:48:24
C outdon - finish off an output line
      SUBROUTINE OUTDON
C------------------------------------------------------------------
C# preprocessor common block to hold output characters
C put on a file named 'coutln'
C Used only by ratfiv preprocessor
      COMMON/COUTLN/OUTP, INDENT, OUTBUF(134)
C last position filled in outbuf; init = 0
      INTEGER OUTP
C current indent level (tab position)
      INTEGER INDENT
C output lines collected here
      INTEGER OUTBUF
C------------------------------------------------------------------
      IF (OUTP .GT. 0) THEN
        OUTBUF(OUTP + 1) = 10
        OUTBUF(OUTP + 2) = 0
        CALL PUTLIN(OUTBUF, 6)
        OUTP = 0
      END IF
      RETURN
      END
C ARCHIVE OUTGO.RAT               16  30-NOV-81 14:24:06
C outgo - output 'goto  n'
      SUBROUTINE OUTGO(N, NEWXF)
      INTEGER N, NEWXF
C------------------------------------------------------------------
C# preprocessor common block to hold output characters
C put on a file named 'coutln'
C Used only by ratfiv preprocessor
      COMMON/COUTLN/OUTP, INDENT, OUTBUF(134)
C last position filled in outbuf; init = 0
      INTEGER OUTP
C current indent level (tab position)
      INTEGER INDENT
C output lines collected here
      INTEGER OUTBUF
C------------------------------------------------------------------
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      INTEGER GOTO(6)
      DATA GOTO(1)/103/,GOTO(2)/111/,GOTO(3)/116/,GOTO(4)/111/,GOTO(5)/3
     *2/,GOTO(6)/0/
      IF (XFER .EQ. 1) THEN
        RETURN
      END IF
      XFER = NEWXF
      CALL OUTTAB
      CALL OUTSTR(GOTO)
      CALL OUTNUM(N)
      CALL OUTDON
      RETURN
      END
C ARCHIVE OUTNUM.RAT              11  30-NOV-81 14:24:06
C outnum - output decimal number
      SUBROUTINE OUTNUM(INT)
      INTEGER INT, I, J
      INTEGER ITOC
      INTEGER STR(7)
      I = ITOC(INT, STR, 7)
      J = 1
      DO WHILE (J .LE. I)
        CALL OUTCH(STR(J))
3200    J = J + 1
      END DO
      RETURN
      END
C ARCHIVE OUTSTR.RAT              44   3-FEB-82 23:22:46
C outstr - output string
      SUBROUTINE OUTSTR(STR)
      INTEGER C, Q, STR(*), CUPPER, NQC
CModif
      INTEGER CC
      INTEGER I, J, K
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
      I = 1
      DO WHILE (STR(I) .NE. 0)
        C = STR(I)
        IF (C .EQ. 96) THEN
          I = I + 1
          DO WHILE (.TRUE.)
            IF (STR(I) .EQ. 96) THEN
              IF (STR(I+1) .EQ. 96) THEN
                I = I + 1
              ELSE
                GOTO 3270
              END IF
            END IF
            CALL OUTCH(STR(I))
3260        I = I + 1
          END DO
3270      CONTINUE
        ELSE IF (STR(I+1) .EQ. 0 .OR. .NOT.((C) .EQ. 39 .OR. (C) .EQ. 34
     *)) THEN
          CALL OUTCH(CUPPER(C))
        ELSE IF (HOLLER) THEN
C hollerith output?
          Q = C
          I = I + 1
          K = 0
          J = I
          DO WHILE (NQC(STR,J,Q,C) .NE. 0)
C find end
            K = K + 1
3290        J = J + 1
          END DO
          CALL OUTNUM(K)
          CC = 72
          CALL OUTCH(CC)
          DO WHILE (NQC(STR,I,Q,C) .NE. 0)
            CALL OUTCH(C)
3320        I = I + 1
          END DO
        ELSE
C quoted output
          Q = C
          CC = 39
          CALL OUTCH(CC)
          I = I + 1
          DO WHILE (NQC(STR,I,Q,C) .NE. 0)
            IF (C .EQ. 39) THEN
              CC = 39
C ' -> ''
              CALL OUTCH(CC)
            END IF
            CALL OUTCH(C)
3350        I = I + 1
          END DO
          CC = 39
          CALL OUTCH(CC)
        END IF
3230    I = I + 1
      END DO
      RETURN
      END
C ARCHIVE OUTTAB.RAT              11  30-NOV-81 14:24:07
C outtab - get past column 6
      SUBROUTINE OUTTAB
      INTEGER I, MOD
C Modif
      INTEGER CC
C------------------------------------------------------------------
C# preprocessor common block to hold output characters
C put on a file named 'coutln'
C Used only by ratfiv preprocessor
      COMMON/COUTLN/OUTP, INDENT, OUTBUF(134)
C last position filled in outbuf; init = 0
      INTEGER OUTP
C current indent level (tab position)
      INTEGER INDENT
C output lines collected here
      INTEGER OUTBUF
C------------------------------------------------------------------
      I = MOD(INDENT, 44) + 6
3370  DO WHILE (OUTP .LT. I)
        CC = 32
        CALL OUTCH(CC)
      END DO
      RETURN
      END
C ARCHIVE PARSE.RAT              140   1-DEC-81 09:55:07
C parse - parse Ratfiv source program
      SUBROUTINE PARSE
      INTEGER LEXSTR(201)
      INTEGER LEX
      INTEGER LAB, LABVAL(100), LEXTYP(100), SP, TOKEN, I
C------------------------------------------------------------------
C# preprocessor common block to hold output characters
C put on a file named 'coutln'
C Used only by ratfiv preprocessor
      COMMON/COUTLN/OUTP, INDENT, OUTBUF(134)
C last position filled in outbuf; init = 0
      INTEGER OUTP
C current indent level (tab position)
      INTEGER INDENT
C output lines collected here
      INTEGER OUTBUF
C------------------------------------------------------------------
C-----------------------------------------------------------------------
C preprocessor common block to hold info about lines and included files
C put on a file named 'cline'
C used by ratfiv preproccessor and macro
      COMMON/CLINE/LEVEL, INFILE(4), LINECT(4), FNAMP(4), FNAMES(920), I
     *OIN(134)
C level of file inclusion; init = 1
      INTEGER LEVEL
C file number(level); init infile(1) = STDIN
      INTEGER INFILE
C line count on input file(level); init = 1
      INTEGER LINECT
C next free slot in fnames
      INTEGER FNAMP
C stack of open file names
      INTEGER FNAMES
C input buffer
      INTEGER IOIN
C----------------------------------------------------------------------
C preprocessor common block to hold input characters
C Put on a file called 'cdefio'
C Used by ratfiv preprocessor and macro
      COMMON/CDEFIO/BP, BPLOW, BPSAVE(4), BUF(900)
C next available character; init = 0
      INTEGER BP
C bottom of push-back buffer at current file level
      INTEGER BPLOW
C holds bplow for active file levels
      INTEGER BPSAVE
C pushed-back characters
      INTEGER BUF
C--------------------------------------------------------------------------
C# preprocessor common block to hold info about 'for' statements
C put on a file named 'cfor'
C Used only by ratfiv preprocessor
      COMMON/CFOR/FORDEP, FORSTK(250)
C current depth of for statements
      INTEGER FORDEP
C stack of reinit strings
      INTEGER FORSTK
C--------------------------------------------------------------------------
C# preprocessor common block to hold current function name
C put on a file named 'cfname'
C Used only by ratfiv preprocessor
      COMMON/CFNAME/FCNAME(35)
Ctext of current function name
      INTEGER FCNAME
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
C# preprocessor common block for holding string statement info
C  Put on a file called 'csbuf'
C  Used only by ratfiv preprocessor
      COMMON/CSBUF/SBP, SBUF(600)
C next available character position; init = 1
      INTEGER SBP
C saved for data statements
      INTEGER SBUF
C# Preprocessor common block used to hold switch info
C  Put on a file named 'cswtch'
C  Used only by ratfiv preprocessor
      COMMON/CSWTCH/SWTOP, SWLAST, SWSTAK(500)
C current switch entry; init = 0
      INTEGER SWTOP
C next available position; init = 1
      INTEGER SWLAST
C switch information
      INTEGER SWSTAK
      INTEGER SDECOD(7)
      INTEGER SENCOD(7)
      INTEGER SREAD(5)
      INTEGER SWRITE(6)
      INTEGER SFORMA(7)
C initialize variables for current input file
      DATA SDECOD(1)/100/,SDECOD(2)/101/,SDECOD(3)/99/,SDECOD(4)/111/,SD
     *ECOD(5)/100/,SDECOD(6)/101/,SDECOD(7)/0/
      DATA SENCOD(1)/101/,SENCOD(2)/110/,SENCOD(3)/99/,SENCOD(4)/111/,SE
     *NCOD(5)/100/,SENCOD(6)/101/,SENCOD(7)/0/
      DATA SREAD(1)/114/,SREAD(2)/101/,SREAD(3)/97/,SREAD(4)/100/,SREAD(
     *5)/0/
      DATA SWRITE(1)/119/,SWRITE(2)/114/,SWRITE(3)/105/,SWRITE(4)/116/,S
     *WRITE(5)/101/,SWRITE(6)/0/
      DATA SFORMA(1)/102/,SFORMA(2)/111/,SFORMA(3)/114/,SFORMA(4)/109/,S
     *FORMA(5)/97/,SFORMA(6)/116/,SFORMA(7)/0/
      OUTP = 0
      INDENT = 0
      LEVEL = 1
      FNAMP(1) = 1
      LINECT(1) = 0
      BP = 0
      SBP = 1
      FORDEP = 0
C controls conversion of > and < to .gt. and .lt.
      INFORM = .FALSE.
      FCNAME(1) = 0
      XFER = 0
      LABEL = 2000
      SWTOP = 0
      SWLAST = 1
      SP = 1
      LEXTYP(1) =  - 10
      TOKEN = LEX(LEXSTR)
      DO WHILE (TOKEN .NE. -10)
        I3420 = (TOKEN)
        GOTO 3420
3440    CONTINUE
          CALL OTHERC(LEXSTR)
          GOTO 3430
3450    CONTINUE
          CALL IFCODE(LAB)
          SP = SP + 1
          GOTO 3430
3460    CONTINUE
          IF (LEXTYP(SP) .EQ. -57 .OR. LEXTYP(SP) .EQ. -74) THEN
            IF (LEX(LEXSTR) .EQ. -57) THEN
C have "else if ..."
              LEXTYP(SP) =  - 74
            ELSE
              CALL PBSTR(LEXSTR)
              LEXTYP(SP) =  - 55
            END IF
            CALL ELSEF(LABVAL(SP - 1), LABVAL(SP), LEXTYP(SP))
            IF (LEXTYP(SP) .EQ. -74) THEN
              CALL IFCODE(LABVAL(SP))
            END IF
          ELSE
            TOKEN =  - 75
            CALL SYNERR('illegal else.')
          END IF
          GOTO 3430
3470    CONTINUE
          CALL DOCODE(LAB)
          GOTO 3430
3480    CONTINUE
          CALL WHILEC(LAB)
          GOTO 3430
3490    CONTINUE
          CALL FORCOD(LAB)
          GOTO 3430
3500    CONTINUE
          CALL REPCOD(LAB)
          GOTO 3430
3510    CONTINUE
          CALL BRKNXT(SP, LEXTYP, LABVAL, TOKEN)
          GOTO 3430
3520    CONTINUE
          CALL LABELC(LEXSTR)
          GOTO 3430
3530    CONTINUE
          CALL SWCODE(LAB)
          GOTO 3430
3540    CONTINUE
          IF (SP .GT. 1 .AND. LEXTYP(MAX0(1, SP-1)) .EQ. -71) THEN
            CALL CASCOD(LABVAL(SP - 1), TOKEN)
          ELSE
            TOKEN =  - 75
            CALL SYNERR('illegal case or default.')
          END IF
          GOTO 3430
3550    CONTINUE
          CALL FORMA(SWRITE)
          GOTO 3430
3560    CONTINUE
          CALL FORMA(SREAD)
          GOTO 3430
3570    CONTINUE
          CALL FORMA(SENCOD)
          GOTO 3430
3580    CONTINUE
          CALL FORMA(SDECOD)
          GOTO 3430
3590    CONTINUE
          INFORM = .TRUE.
          CALL OTHERC(SFORMA)
          INFORM = .FALSE.
          GOTO 3430
3600    CONTINUE
          CALL RINCLU
          GOTO 3430
3610    CONTINUE
          CALL DFUNCT
          GOTO 3430
3620    CONTINUE
          CALL RETCOD
          GOTO 3430
3630    CONTINUE
          CALL STRDCL
          GOTO 3430
3640    CONTINUE
          CALL LITRAL
          GOTO 3430
3650    CONTINUE
          IF (TOKEN .EQ. 93) THEN
            IF (LEXTYP(SP) .EQ. 91) THEN
              SP = SP - 1
            ELSE
              CALL SYNERR('illegal right brace.')
            END IF
          END IF
          GOTO 3430
3420    CONTINUE
        I3420 = I3420+74
        GOTO (3540,3540,3530,3630,3590,3580,3570,3560,3550,3480,3650,362
     *0,3500,3440,3510,3640,3450,3490,3460,3470,3520,3510,3610,3600), I3
     *420
        GOTO 3650
3430    CONTINUE
        IF (TOKEN .EQ. -57 .OR. TOKEN .EQ. -64 .OR. TOKEN .EQ. -56 .OR. 
     *TOKEN .EQ. -61 .OR. TOKEN .EQ. -71 .OR. TOKEN .EQ. -54 .OR. TOKEN 
     *.EQ. -53 .OR. TOKEN .EQ. 91) THEN
C beginning of statement
          SP = SP + 1
          IF (SP .GT. 100) THEN
            CALL FATAL('stack overflow in parser.')
          END IF
C stack type and value
          LEXTYP(SP) = TOKEN
          LABVAL(SP) = LAB
          IF (TOKEN .EQ. -57) THEN
            LEXTYP(SP - 1) = TOKEN
            LABVAL(SP - 1) = LAB + 10
          END IF
        ELSE IF (TOKEN .NE. -55) THEN
C end of statement - prepare to unstack
C peek at next token
          TOKEN = LEX(LEXSTR)
          CALL PBSTR(LEXSTR)
          CALL UNSTAK(SP, LEXTYP, LABVAL, TOKEN)
        END IF
3400    TOKEN = LEX(LEXSTR)
      END DO
      IF (SP .NE. 1) THEN
        CALL SYNERR('unexpected EOF.')
      END IF
      RETURN
      END
C ARCHIVE RAT5S.RAT               83   1-DEC-81 11:28:22
C rat5s - driver subroutine for ratfiv compiler
      SUBROUTINE RAT5S
      INTEGER GTARG, OPEN, PMATCH
      INTEGER BUF(134)
      INTEGER I, ARG1
C-----------------------------------------------------------------------
C preprocessor common block to hold info about lines and included files
C put on a file named 'cline'
C used by ratfiv preproccessor and macro
      COMMON/CLINE/LEVEL, INFILE(4), LINECT(4), FNAMP(4), FNAMES(920), I
     *OIN(134)
C level of file inclusion; init = 1
      INTEGER LEVEL
C file number(level); init infile(1) = STDIN
      INTEGER INFILE
C line count on input file(level); init = 1
      INTEGER LINECT
C next free slot in fnames
      INTEGER FNAMP
C stack of open file names
      INTEGER FNAMES
C input buffer
      INTEGER IOIN
C needed to set input file
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
      INTEGER SYMBLS(8)
C file containing general definitions
      INTEGER SYMFLG(9)
C /SYMBOLS switch
      INTEGER F77SW(5)
C Fortran 77 switch
      INTEGER F77USW(5)
C Fortran 77 switch
      INTEGER HOLLSW(11)
C output hollerith strings switch
      INTEGER HOLLUSW(11)
C output hollerith strings switch
      INTEGER STDINN(6)
C STDIN string
      DATA SYMBLS(1)/115/,SYMBLS(2)/121/,SYMBLS(3)/109/,SYMBLS(4)/98/,SY
     *MBLS(5)/111/,SYMBLS(6)/108/,SYMBLS(7)/115/,SYMBLS(8)/0/
      DATA SYMFLG(1)/47/,SYMFLG(2)/115/,SYMFLG(3)/121/,SYMFLG(4)/109/,SY
     *MFLG(5)/98/,SYMFLG(6)/111/,SYMFLG(7)/108/,SYMFLG(8)/115/,SYMFLG(9)
     */0/
      DATA F77SW(1)/47/,F77SW(2)/102/,F77SW(3)/55/,F77SW(4)/55/,F77SW(5)
     */0/
      DATA F77USW(1)/47/,F77USW(2)/70/,F77USW(3)/55/,F77USW(4)/55/,F77US
     *W(5)/0/
      DATA HOLLSW(1)/47/,HOLLSW(2)/104/,HOLLSW(3)/111/,HOLLSW(4)/108/,HO
     *LLSW(5)/108/,HOLLSW(6)/101/,HOLLSW(7)/114/,HOLLSW(8)/105/,HOLLSW(9
     *)/116/,HOLLSW(10)/104/,HOLLSW(11)/0/
      DATA HOLLUSW(1)/47/,HOLLUSW(2)/72/,HOLLUSW(3)/79/,HOLLUSW(4)/76/,H
     *OLLUSW(5)/76/,HOLLUSW(6)/69/,HOLLUSW(7)/82/,HOLLUSW(8)/73/,HOLLUSW
     *(9)/84/,HOLLUSW(10)/72/,HOLLUSW(11)/0/
      DATA STDINN(1)/83/,STDINN(2)/84/,STDINN(3)/68/,STDINN(4)/73/,STDIN
     *N(5)/78/,STDINN(6)/0/
C initialize macro processor
      CALL INIMAC
C initialize ratfiv
      CALL INIRAT
      F77 = .FALSE.
      HOLLER = .FALSE.
      ARG1 = 1
      DO WHILE (GTARG(ARG1,BUF,134) .NE. -10)
        IF (BUF(1) .NE. 47) THEN
          GOTO 3680
        ELSE IF (PMATCH(BUF, SYMFLG) .EQ. 1) THEN
C read file containing standard defs
          CALL SCOPY(SYMBLS, 1, FNAMES, 1)
          INFILE(1) = OPEN(SYMBLS, 114)
          IF (INFILE(1) .EQ. -1) THEN
C then try system-wide symbols file
C get location of system-wide file
            CALL USRBIN(FNAMES)
            I = 1
            DO WHILE (FNAMES(I) .NE. 0)
C move pointer to end
3700          I = I + 1
            END DO
C copy remainder of name
            CALL SCOPY(SYMBLS, 1, FNAMES, I)
            INFILE(1) = OPEN(FNAMES, 114)
          END IF
          IF (INFILE(1) .EQ. -1) THEN
            CALL ERROR('can''t open symbols file.')
          ELSE
            CALL PARSE
            CALL CLOSE(INFILE(1))
          END IF
        ELSE IF ((PMATCH(BUF, F77SW) .EQ. 1) .OR. (PMATCH(BUF, F77USW) .
     *EQ. 1)) THEN
          F77 = .TRUE.
        ELSE IF ((PMATCH(BUF, HOLLSW) .EQ. 1) .OR. (PMATCH(BUF, HOLLUSW)
     * .EQ. 1)) THEN
          HOLLER = .TRUE.
        ELSE
          CALL PUTLIN(BUF, 0)
          CALL ERROR(': illegal switch.')
C loop through all input files
        END IF
3670    ARG1 = ARG1 + 1
      END DO
3680  CONTINUE
      I = ARG1
      DO WHILE (.TRUE.)
        IF (GTARG(I, BUF, 134) .EQ. -10) THEN
          IF (I .NE. ARG1) THEN
            GOTO 3740
          END IF
          INFILE(1) = 5
          CALL SCOPY(STDINN, 1, FNAMES, 1)
        ELSE IF (BUF(1) .EQ. 63 .AND. BUF(2) .EQ. 0) THEN
          CALL REMARK('usage:  rat[/symbols][/hollerith][/f77] [file ...
     *] [>outfile].')
        ELSE IF (BUF(1) .EQ. 45 .AND. BUF(2) .EQ. 0) THEN
          INFILE(1) = 5
          CALL SCOPY(STDINN, 1, FNAMES, 1)
        ELSE
          INFILE(1) = OPEN(BUF, 114)
          CALL SCOPY(BUF, 1, FNAMES, 1)
          IF (INFILE(1) .EQ. -1) THEN
            CALL CANT(BUF)
          END IF
        END IF
        CALL PARSE
        IF (INFILE(1) .NE. 5) THEN
          CALL CLOSE(INFILE(1))
        END IF
3730    I = I + 1
      END DO
3740  CONTINUE
      RETURN
      END
C ARCHIVE RATMAIN.RAT              7   1-DEC-81 11:29:40
C ratfiv -- main program
C remove this if necessary on your system
      PROGRAM RATFIV
      CALL INITR4
      CALL RAT5S
      CALL ENDR4
      END
C ARCHIVE RELATE.RAT              61  30-NOV-81 14:24:09
C relate - convert relational shorthands into long form
      SUBROUTINE RELATE(TOKEN, LAST)
      INTEGER NGETCH
      INTEGER TOKEN(*)
      INTEGER LENGTH
      INTEGER LAST
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
      INTEGER DOTGE(9), DOTGT(9), DOTLT(9), DOTLE(9)
      INTEGER DOTNE(9), DOTNOT(8), DOTEQ(9), DOTAND(10), DOTOR(9)
      DATA DOTGE/96, 32, 46, 71, 69, 46, 32, 96, 0/
      DATA DOTGT/96, 32, 46, 71, 84, 46, 32, 96, 0/
      DATA DOTLE/96, 32, 46, 76, 69, 46, 32, 96, 0/
      DATA DOTLT/96, 32, 46, 76, 84, 46, 32, 96, 0/
      DATA DOTNE/96, 32, 46, 78, 69, 46, 32, 96, 0/
      DATA DOTEQ/96, 32, 46, 69, 81, 46, 32, 96, 0/
      DATA DOTOR/96, 32, 46, 79, 82, 46, 32, 96, 0/
      DATA DOTAND/96, 32, 46, 65, 78, 68, 46, 32, 96, 0/
      DATA DOTNOT/96, 46, 78, 79, 84, 46, 96, 0/
      IF (NGETCH(TOKEN(2)) .NE. 61) THEN
        CALL PUTBAK(TOKEN(2))
      END IF
      IF (TOKEN(1) .EQ. 62) THEN
        IF (TOKEN(2) .EQ. 61) THEN
          CALL SCOPY(DOTGE, 1, TOKEN, 1)
        ELSE IF (INFORM) THEN
          TOKEN(2) = 0
        ELSE
          CALL SCOPY(DOTGT, 1, TOKEN, 1)
        END IF
      ELSE IF (TOKEN(1) .EQ. 60) THEN
        IF (TOKEN(2) .EQ. 61) THEN
          CALL SCOPY(DOTLE, 1, TOKEN, 1)
        ELSE IF (INFORM) THEN
          TOKEN(2) = 0
        ELSE
          CALL SCOPY(DOTLT, 1, TOKEN, 1)
        END IF
      ELSE IF (TOKEN(1) .EQ. 126 .OR. TOKEN(1) .EQ. 33 .OR. TOKEN(1) .EQ
     *. 94) THEN
        IF (TOKEN(2) .EQ. 61) THEN
          CALL SCOPY(DOTNE, 1, TOKEN, 1)
        ELSE
          CALL SCOPY(DOTNOT, 1, TOKEN, 1)
        END IF
      ELSE IF (TOKEN(1) .EQ. 61) THEN
        IF (TOKEN(2) .EQ. 61) THEN
          CALL SCOPY(DOTEQ, 1, TOKEN, 1)
        ELSE
          TOKEN(2) = 0
        END IF
      ELSE IF (TOKEN(1) .EQ. 38) THEN
        CALL SCOPY(DOTAND, 1, TOKEN, 1)
      ELSE IF (TOKEN(1) .EQ. 124 .OR. TOKEN(1) .EQ. 92) THEN
        CALL SCOPY(DOTOR, 1, TOKEN, 1)
C can't happen
      ELSE
        TOKEN(2) = 0
      END IF
      LAST = LENGTH(TOKEN)
      RETURN
      END
C ARCHIVE REPCOD.RAT              12   3-FEB-82 23:23:39
C repcod - generate code for beginning of repeat
      SUBROUTINE REPCOD(LAB)
      INTEGER LABGEN
      INTEGER LAB
C in case there was a label
      CALL OUTCON(0)
      LAB = LABGEN(3)
      CALL OUTCON(LAB)
      CALL INDEN(2)
C label to go to if next
      LAB =  - (LAB + 10)
      RETURN
      END
C ARCHIVE RETCOD.RAT              29  30-NOV-81 14:24:09
C retcod - generate code for return
      SUBROUTINE RETCOD
      INTEGER TOKEN(201), GETTOK, T
C--------------------------------------------------------------------------
C# preprocessor common block to hold current function name
C put on a file named 'cfname'
C Used only by ratfiv preprocessor
      COMMON/CFNAME/FCNAME(35)
Ctext of current function name
      INTEGER FCNAME
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      INTEGER RETRN(7)
      INTEGER EQS(4)
      DATA RETRN(1)/114/,RETRN(2)/101/,RETRN(3)/116/,RETRN(4)/117/,RETRN
     *(5)/114/,RETRN(6)/110/,RETRN(7)/0/
      DATA EQS(1)/32/,EQS(2)/61/,EQS(3)/32/,EQS(4)/0/
      T = GETTOK(TOKEN, 201)
      IF (T .EQ. 59 .OR. T .EQ. 10 .OR. T .EQ. -10 .OR. T .EQ. 93 .OR. T
     * .EQ. 91 .OR. (T .LT. 0 .AND. T .NE. 1)) THEN
        CALL PBSTR(TOKEN)
      ELSE
        CALL PBSTR(TOKEN)
        CALL OUTTAB
        IF (FCNAME(1) .EQ. 0) THEN
          CALL SYNERR('return: no function defined.')
        ELSE
          CALL OUTSTR(FCNAME)
          CALL OUTSTR(EQS)
        END IF
        CALL EATUP
      END IF
      CALL OUTTAB
      CALL OUTSTR(RETRN)
      CALL OUTDON
      XFER = 1
      RETURN
      END
C ARCHIVE RINCLU.RAT              29  16-DEC-81 23:27:37
C rinclu - do include for ratfiv
      SUBROUTINE RINCLU
      INTEGER FILE(230), T, BUF(201), NQC, C, BRKCHR(5)
      INTEGER GETTOK, DEFTOK
      INTEGER I, J, INDEXX
      DATA BRKCHR/59, 32, 9, 10, 0/
      T = GETTOK(BUF, 201)
      IF (((T) .EQ. 39 .OR. (T) .EQ. 34) .AND. BUF(2) .NE. 0) THEN
C include "file" or 'file'
        I = 1
        J = 2
        DO WHILE (I .LE. 230 .AND. NQC(BUF,J,T,C) .NE. 0)
          FILE(I) = C
          I = I + 1
3760      J = J + 1
        END DO
C include file
      ELSE
        I = 1
        DO WHILE (T .NE. -10 .AND. INDEXX(BRKCHR,T) .EQ. 0)
          J = 1
          DO WHILE (I .LE. 230 .AND. BUF(J) .NE. 0)
            FILE(I) = BUF(J)
            I = I + 1
3820        J = J + 1
          END DO
3790      T = DEFTOK(BUF, 201)
        END DO
      END IF
      IF (I .GT. 230) THEN
        CALL SYNERR('include file name too long.')
      ELSE
        FILE(I) = 0
        CALL INCLUD(FILE)
      END IF
      RETURN
      END
C ARCHIVE SKPOUT.RAT              26  30-NOV-81 14:24:10
      SUBROUTINE SKPOUT(T)
      INTEGER T, TOK(201), GETTOK
C Modif NB
      INTEGER CC
      INTEGER NLPAR
      NLPAR = 0
3840  CONTINUE
        T = GETTOK(TOK, 201)
        IF (T .EQ. -10) THEN
          CALL PBSTR(TOK)
          CALL SYNERR('unexpected EOF.')
          RETURN
        END IF
        IF (T .EQ. 40) THEN
          NLPAR = NLPAR + 1
        ELSE IF (T .EQ. 41) THEN
          NLPAR = NLPAR - 1
        END IF
        IF (T .NE. 10) THEN
          CALL OUTSTR(TOK)
          IF (T .EQ. 44) THEN
            CC = 32
            CALL OUTCH(CC)
          END IF
        END IF
3850  IF (.NOT.(NLPAR .LT. 0 .OR. (T .EQ. 44 .AND. NLPAR .EQ. 0))) GOTO 
     *3840
      IF (T .EQ. 41) THEN
        CC = 32
        CALL OUTCH(CC)
      END IF
      RETURN
      END
C ARCHIVE STRDCL.RAT              78   3-FEB-82 00:29:19
C strdcl - generate code for string declaration
      SUBROUTINE STRDCL
      INTEGER T, TOKEN(201), GETTOK, ESC
CModif NB
      INTEGER CC
      INTEGER I, J, K, N, LEN
      INTEGER LENGTH, CTOI, LEX, ELENTH
C# preprocessor common block for holding string statement info
C  Put on a file called 'csbuf'
C  Used only by ratfiv preprocessor
      COMMON/CSBUF/SBP, SBUF(600)
C next available character position; init = 1
      INTEGER SBP
C saved for data statements
      INTEGER SBUF
      INTEGER CHAR(10)
      INTEGER CHARDF(8)
C default definition for character
      INTEGER EOSS(4)
      INTEGER EOSDF(2)
C default definition for EOS
      INTEGER DAT(6)
      DATA CHAR(1)/99/,CHAR(2)/104/,CHAR(3)/97/,CHAR(4)/114/,CHAR(5)/97/
     *,CHAR(6)/99/,CHAR(7)/116/,CHAR(8)/101/,CHAR(9)/114/,CHAR(10)/0/
      DATA CHARDF(1)/105/,CHARDF(2)/110/,CHARDF(3)/116/,CHARDF(4)/101/,C
     *HARDF(5)/103/,CHARDF(6)/101/,CHARDF(7)/114/,CHARDF(8)/0/
      DATA EOSS(1)/69/,EOSS(2)/79/,EOSS(3)/83/,EOSS(4)/0/
      DATA EOSDF(1)/48/,EOSDF(2)/0/
      DATA DAT(1)/100/,DAT(2)/97/,DAT(3)/116/,DAT(4)/97/,DAT(5)/32/,DAT(
     *6)/0/
3870  CONTINUE
        T = GETTOK(TOKEN, 201)
        IF (T .NE. 1) THEN
          CALL SYNERR('missing string token.')
        END IF
        CALL OUTTAB
C try to use defined meaning of "character"
        CALL OUTDEF(CHAR, CHARDF)
        CC = 32
C separator in declaration
        CALL OUTCH(CC)
        CALL OUTSTR(TOKEN)
C save for later
        CALL ADDSTR(TOKEN, SBUF, SBP, 600)
        CC = 0
        CALL ADDCHR(CC, SBUF, SBP, 600)
        IF (GETTOK(TOKEN, 201) .NE. 40) THEN
C make size same as initial value
          LEN = ELENTH(TOKEN) + 1
        ELSE
Cform is string name(size) init
          T = GETTOK(TOKEN, 201)
          I = 1
          LEN = CTOI(TOKEN, I)
          IF (TOKEN(I) .NE. 0) THEN
            CALL SYNERR('invalid string size.')
          END IF
          IF (GETTOK(TOKEN, 201) .NE. 41) THEN
            CALL SYNERR('missing right paren.')
          ELSE
            T = GETTOK(TOKEN, 201)
          END IF
C un-quote token
          I = ELENTH(TOKEN)
        END IF
        CC = 40
        CALL OUTCH(CC)
        CALL OUTNUM(LEN)
        CC = 41
        CALL OUTCH(CC)
        CALL OUTDON
        CALL ADDSTR(TOKEN, SBUF, SBP, 600)
        CC = 0
        CALL ADDCHR(CC, SBUF, SBP, 600)
C peek at next token
        T = GETTOK(TOKEN, 201)
        IF (T .EQ. 44) THEN
C string ..., ...
3900      DO WHILE (GETTOK(TOKEN, 201) .EQ. 10)
          END DO
        END IF
        CALL PBSTR(TOKEN)
3880  IF (.NOT.(T .NE. 44)) GOTO 3870
      T = LEX(TOKEN)
      CALL PBSTR(TOKEN)
      IF (T .NE. -70) THEN
C dump accumulated data statements
        I = 1
        DO WHILE (I .LT. SBP)
          CALL OUTTAB
          CALL OUTSTR(DAT)
          K = 1
          J = I + LENGTH(SBUF(I)) + 1
          DO WHILE (.TRUE.)
            IF (K .GT. 1) THEN
              CC = 44
              CALL OUTCH(CC)
            END IF
            CALL OUTSTR(SBUF(I))
            CC = 40
            CALL OUTCH(CC)
            CALL OUTNUM(K)
            CC = 41
            CALL OUTCH(CC)
            CC = 47
            CALL OUTCH(CC)
            IF (SBUF(J) .EQ. 0) THEN
              GOTO 3970
            END IF
            N = ESC(SBUF, J)
            CALL OUTNUM(N)
            CC = 47
            CALL OUTCH(CC)
            K = K + 1
3960        J = J + 1
          END DO
3970      CONTINUE
C try to use defined meaning of EOS
          CALL OUTDEF(EOSS, EOSDF)
          CC = 47
          CALL OUTCH(CC)
          CALL OUTDON
3930      I = J + 1
        END DO
        SBP = 1
      END IF
      RETURN
      END
C ARCHIVE SWCODE.RAT              34  30-NOV-81 14:24:11
C swcode - generate code for beginning of switch statement
      SUBROUTINE SWCODE(LAB)
      INTEGER LAB, LABGEN
      INTEGER TOK(201), GETTOK
CModif NB
      INTEGER CC
C# Preprocessor common block used to hold switch info
C  Put on a file named 'cswtch'
C  Used only by ratfiv preprocessor
      COMMON/CSWTCH/SWTOP, SWLAST, SWSTAK(500)
C current switch entry; init = 0
      INTEGER SWTOP
C next available position; init = 1
      INTEGER SWLAST
C switch information
      INTEGER SWSTAK
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      INTEGER EQS(4)
      DATA EQS(1)/32/,EQS(2)/61/,EQS(3)/32/,EQS(4)/0/
      LAB = LABGEN(2)
      IF (SWLAST+3 .GT. 500) THEN
        CALL FATAL('switch table overflow.')
      END IF
      SWSTAK(SWLAST) = SWTOP
      SWSTAK(SWLAST + 1) = 0
      SWSTAK(SWLAST + 2) = 0
      SWTOP = SWLAST
      SWLAST = SWLAST + 3
      XFER = 0
C Innn=(e)
      CALL OUTTAB
      CALL SWVAR(LAB)
      CALL OUTSTR(EQS)
      CALL BALPAR
      CALL OUTDON
C goto L
      CALL OUTGO(LAB, 1)
      CALL INDEN(2)
3980  DO WHILE (GETTOK(TOK, 201) .EQ. 10)
      END DO
      IF (TOK(1) .NE. 91) THEN
        CALL SYNERR('missing left brace in switch statement.')
        CALL PBSTR(TOK)
      END IF
      CC = 91
      CALL PUTBAK(CC)
      RETURN
      END
C ARCHIVE SWEND.RAT              102   8-APR-82 09:43:13
C swend - finish off switch statement; generate dispatch code
      SUBROUTINE SWEND(LAB)
      INTEGER LAB, LB, UB, N, I, J
CModif
      INTEGER CC
C# Preprocessor common block used to hold switch info
C  Put on a file named 'cswtch'
C  Used only by ratfiv preprocessor
      COMMON/CSWTCH/SWTOP, SWLAST, SWSTAK(500)
C current switch entry; init = 0
      INTEGER SWTOP
C next available position; init = 1
      INTEGER SWLAST
C switch information
      INTEGER SWSTAK
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
      INTEGER SIF(5)
      INTEGER SLT(14)
      INTEGER SGT(7)
      INTEGER SGOTO(7)
      INTEGER SEQ(7)
      INTEGER SGE(7)
      INTEGER SLE(7)
      INTEGER SAND(8)
      INTEGER EQS(4)
      DATA SIF(1)/105/,SIF(2)/102/,SIF(3)/32/,SIF(4)/40/,SIF(5)/0/
      DATA SLT(1)/32/,SLT(2)/46/,SLT(3)/108/,SLT(4)/116/,SLT(5)/46/,SLT(
     *6)/32/,SLT(7)/49/,SLT(8)/32/,SLT(9)/46/,SLT(10)/111/,SLT(11)/114/,
     *SLT(12)/46/,SLT(13)/32/,SLT(14)/0/
      DATA SGT(1)/32/,SGT(2)/46/,SGT(3)/103/,SGT(4)/116/,SGT(5)/46/,SGT(
     *6)/32/,SGT(7)/0/
      DATA SGOTO(1)/103/,SGOTO(2)/111/,SGOTO(3)/116/,SGOTO(4)/111/,SGOTO
     *(5)/32/,SGOTO(6)/40/,SGOTO(7)/0/
      DATA SEQ(1)/32/,SEQ(2)/46/,SEQ(3)/101/,SEQ(4)/113/,SEQ(5)/46/,SEQ(
     *6)/32/,SEQ(7)/0/
      DATA SGE(1)/32/,SGE(2)/46/,SGE(3)/103/,SGE(4)/101/,SGE(5)/46/,SGE(
     *6)/32/,SGE(7)/0/
      DATA SLE(1)/32/,SLE(2)/46/,SLE(3)/108/,SLE(4)/101/,SLE(5)/46/,SLE(
     *6)/32/,SLE(7)/0/
      DATA SAND(1)/32/,SAND(2)/46/,SAND(3)/97/,SAND(4)/110/,SAND(5)/100/
     *,SAND(6)/46/,SAND(7)/32/,SAND(8)/0/
      DATA EQS(1)/32/,EQS(2)/61/,EQS(3)/32/,EQS(4)/0/
      LB = SWSTAK(SWTOP + 3)
      UB = SWSTAK(SWLAST - 2)
      N = SWSTAK(SWTOP + 1)
C terminate last case
      CALL OUTGO(LAB + 10, 1)
      CALL INDEN( - (2))
      IF (SWSTAK(SWTOP+2) .EQ. 0) THEN
C default default label
        SWSTAK(SWTOP + 2) = LAB + 10
      END IF
C L   continue
      CALL OUTCON(LAB)
      IF (N .GE. 4 .AND. UB-LB+1 .LE. 3*N .AND. LB .GT. -32767) THEN
C output branch table
        IF (LB .NE. 1) THEN
C L  Innn=Innn-lb+1
          CALL OUTTAB
          CALL SWVAR(LAB)
          CALL OUTSTR(EQS)
          CALL SWVAR(LAB)
          IF (LB .LT. 1) THEN
            CC = 43
            CALL OUTCH(CC)
          END IF
          CALL OUTNUM( - LB + 1)
          CALL OUTDON
        END IF
        IF (.NOT.F77) THEN
C  if(Innn.lt.1.or.Innn.gt.ub-lb+1)goto default
          CALL OUTTAB
          CALL OUTSTR(SIF)
          CALL SWVAR(LAB)
          CALL OUTSTR(SLT)
          CALL SWVAR(LAB)
          CALL OUTSTR(SGT)
          CALL OUTNUM(UB - LB + 1)
          CC = 41
          CALL OUTCH(CC)
          CC = 32
          CALL OUTCH(CC)
          CALL OUTGO(SWSTAK(SWTOP + 2), 0)
        END IF
C  goto (....),Innn
        CALL OUTTAB
        CALL OUTSTR(SGOTO)
        J = LB
        I = SWTOP + 3
        DO WHILE (I .LT. SWLAST)
          DO WHILE (J .LT. SWSTAK(I))
C fill in vacancies
            CALL OUTNUM(SWSTAK(SWTOP + 2))
            CC = 44
            CALL OUTCH(CC)
4040        J = J + 1
          END DO
          J = SWSTAK(I + 1) - SWSTAK(I)
          DO WHILE (J .GE. 0)
C fill in range
            CALL OUTNUM(SWSTAK(I + 2))
            IF (J .GT. 0) THEN
              CC = 44
              CALL OUTCH(CC)
            END IF
4070        J = J - 1
          END DO
          J = SWSTAK(I + 1) + 1
          IF (I .LT. SWLAST-3) THEN
            CC = 44
            CALL OUTCH(CC)
          END IF
4010      I = I + 3
        END DO
        CC = 41
        CALL OUTCH(CC)
        CC = 44
        CALL OUTCH(CC)
        CC = 32
        CALL OUTCH(CC)
        CALL SWVAR(LAB)
        CALL OUTDON
        IF (F77 .AND. LAB+10 .NE. SWSTAK(SWTOP+2)) THEN
C goto default
          CALL OUTGO(SWSTAK(SWTOP + 2), 1)
        END IF
      ELSE IF (N .GT. 0) THEN
C output linear search form
        I = SWTOP + 3
        DO WHILE (I .LT. SWLAST)
C if(Innn
          CALL OUTTAB
          CALL OUTSTR(SIF)
          CALL SWVAR(LAB)
          IF (SWSTAK(I) .EQ. SWSTAK(I+1)) THEN
C   .eq....
            CALL OUTSTR(SEQ)
            CALL OUTNUM(SWSTAK(I))
          ELSE
C   .ge.lb.and.Innn.le.ub
            CALL OUTSTR(SGE)
            CALL OUTNUM(SWSTAK(I))
            CALL OUTSTR(SAND)
            CALL SWVAR(LAB)
            CALL OUTSTR(SLE)
            CALL OUTNUM(SWSTAK(I + 1))
          END IF
          CC = 41
C    ) goto ...
          CALL OUTCH(CC)
          CC = 32
          CALL OUTCH(CC)
          CALL OUTGO(SWSTAK(I + 2), 0)
4100      I = I + 3
        END DO
        IF (LAB+10 .NE. SWSTAK(SWTOP+2)) THEN
          CALL OUTGO(SWSTAK(SWTOP + 2), 1)
        END IF
      END IF
C L+10  continue
      CALL OUTCON(LAB + 10)
C pop switch stack
      SWLAST = SWTOP
      SWTOP = SWSTAK(SWTOP)
      RETURN
      END
C ARCHIVE SWVAR.RAT                8  30-NOV-81 14:24:12
C swvar - output switch variable Innn, where nnn = lab
      SUBROUTINE SWVAR(LAB)
      INTEGER LAB
C Modif
      INTEGER CC
      CC = 73
      CALL OUTCH(CC)
      CALL OUTNUM(LAB)
      RETURN
      END
C ARCHIVE UNSTAK.RAT              26  30-NOV-81 14:24:12
C unstak - unstack at end of statement
      SUBROUTINE UNSTAK(SP, LEXTYP, LABVAL, TOKEN)
      INTEGER LABVAL(100), LEXTYP(100), SP, TOKEN
      DO WHILE (SP .GT. 1)
        IF (LEXTYP(SP) .EQ. 91) THEN
          GOTO 4140
        END IF
        IF ((LEXTYP(SP) .EQ. -57 .OR. LEXTYP(SP) .EQ. -74) .AND. TOKEN .
     *EQ. -55) THEN
          GOTO 4140
        END IF
        I4150 = (LEXTYP(SP))
        GOTO 4150
4170    CONTINUE
          CALL IFS(SP, LEXTYP, LABVAL)
          GOTO 4160
4180    CONTINUE
          CALL DOSTAT(LABVAL(SP))
          GOTO 4160
4190    CONTINUE
          CALL WHILES(LABVAL(SP))
          GOTO 4160
4200    CONTINUE
          CALL FORS(LABVAL(SP))
          GOTO 4160
4210    CONTINUE
          CALL UNTILS(LABVAL(SP), TOKEN)
          GOTO 4160
4220    CONTINUE
          CALL SWEND(LABVAL(SP))
          GOTO 4160
4150    CONTINUE
        I4150 = I4150+75
        GOTO (4170,4160,4160,4220,4160,4160,4160,4160,4160,4160,4190,416
     *0,4160,4210,4160,4160,4160,4170,4200,4170,4180), I4150
4160    CONTINUE
4130    SP = SP - 1
      END DO
4140  CONTINUE
      RETURN
      END
C ARCHIVE UNTILS.RAT              20  30-NOV-81 14:24:12
C untils - generate code for until or end of repeat
      SUBROUTINE UNTILS(LAB, TOKEN)
      INTEGER PTOKEN(201)
      INTEGER LEX
      INTEGER JUNK, LAB, TOKEN
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      XFER = 0
      CALL INDEN( - (2))
      CALL OUTNUM(IABS(LAB))
      IF (TOKEN .EQ. -63) THEN
        JUNK = LEX(PTOKEN)
        CALL IFGO(IABS(LAB) - 10)
      ELSE
        CALL OUTGO(IABS(LAB) - 10, 1)
      END IF
      IF (LAB .GT. 0) THEN
C break seen
        CALL OUTCON(LAB + 10)
      END IF
      RETURN
      END
C ARCHIVE WHILEC.RAT              22  30-NOV-81 14:24:12
C whilec - generate code for beginning of while
      SUBROUTINE WHILEC(LAB)
      INTEGER LABGEN
      INTEGER LAB
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
      INTEGER WHILES(10)
      DATA WHILES(1)/100/,WHILES(2)/111/,WHILES(3)/32/,WHILES(4)/119/,WH
     *ILES(5)/104/,WHILES(6)/105/,WHILES(7)/108/,WHILES(8)/101/,WHILES(9
     *)/32/,WHILES(10)/0/
C unlabeled continue, in case there was a label
      CALL OUTCON(0)
      LAB = LABGEN(2)
      CALL OUTNUM(LAB)
      IF (F77) THEN
        CALL OUTTAB
        CALL OUTSTR(WHILES)
        CALL BALPAR
        CALL OUTDON
        LAB =  - LAB
      ELSE
        CALL IFGO(LAB + 10)
      END IF
      CALL INDEN(2)
      RETURN
      END
C ARCHIVE WHILES.RAT              20  30-NOV-81 14:24:13
C whiles - generate code for end of while
      SUBROUTINE WHILES(LAB)
      INTEGER LAB
C------------------------------------------------------------------
C# preprocessor common block to hold flags
C put on a file named 'cflags'
C Used only by ratfiv preprocessor
      COMMON/CFLAGS/INFORM, F77, HOLLER
C when .true., < and > aren't
C converted to .lt. and .gt.
C when .true., output is Fortran 77
C when .true., hollerith strings
      LOGICAL INFORM, F77, HOLLER
C are output instead of quoted strings
C--------------------------------------------------------------------
C# preprocessor common block to hold 'goto' flags and current label
C put on a file named 'cgoto'
C Used only by ratfiv preprocessor
      COMMON/CGOTO/LABEL, XFER
C holds next label for goto, etc.
      INTEGER LABEL
C YES if just made transfer; else NO
      INTEGER XFER
      INTEGER ENDDOS(7)
      DATA ENDDOS(1)/101/,ENDDOS(2)/110/,ENDDOS(3)/100/,ENDDOS(4)/32/,EN
     *DDOS(5)/100/,ENDDOS(6)/111/,ENDDOS(7)/0/
      CALL INDEN( - (2))
      IF (F77) THEN
        CALL OUTTAB
        CALL OUTSTR(ENDDOS)
        CALL OUTDON
        XFER = 0
      ELSE
        CALL OUTGO(LAB, 1)
      END IF
      IF (LAB .GT. 0) THEN
C break seen or not Fortran 77 output
        CALL OUTCON(LAB + 10)
      END IF
      RETURN
      END
C ARCHIVE MACRO.HDR               51   3-MAR-82 00:04:15
C
C
C
C    MACRO preprocessor
C    ==================
C
C         Authors: Original by B. Kernighan and P. J. Plauger,
C                  with rewrites and enhancements by David Hanson and
C                  friends (U. of Arizona), Joe Sventek and Debbie
C                  Scherrer (Lawrence Berkely Laboratory), and
C                  William P. Wood, Jr. (Institute For Cancer Research).
C
C         Address: William P. Wood, Jr.
C                  Computer Center
C                  Institute For Cancer Research
C                  7701 Burholme Ave.
C                  Philadelphia, Pa. 19111
C                  (215) 728 2760
C
C         Version: 2.1
C
C         Date:    March 3, 1982
C
C
C
C      *******************************************************
C      *                                                     *
C      *      THIS SOFTWARE WAS DEVELOPED WITH SUPPORT       *
C      *      FROM THE NATIONAL INSTITUTES OF HEALTH:        *
C      *         NIH CA06927                                 *
C      *         NIH CA22780                                 *
C      *                                                     *
C      *      DIRECT INQUIRIES TO:                           *
C      *            COMPUTER CENTER                          *
C      *            THE INSTITUTE FOR CANCER RESEARCH        *
C      *            7701 BURHOLME AVENUE                     *
C      *            PHILADELPHIA, PENNSYLVANIA   19111       *
C      *                                                     *
C      *      NO WARRANTY OR REPRESENTATION, EXPRESS OR      *
C      *      IMPLIED, IS MADE WITH RESPECT TO THE           *
C      *      CORRECTNESS, COMPLETENESS, OR USEFULNESS       *
C      *      OF THIS SOFTWARE, NOR THAT USE OF THIS         *
C      *      SOFTWARE MIGHT NOT INFRINGE PRIVATELY          *
C      *      OWNED RIGHTS.                                  *
C      *                                                     *
C      *      NO LIABILITY IS ASSUMED WITH RESPECT TO        *
C      *      THE USE OF, OR FOR DAMAGES RESULTING FROM      *
C      *      THE USE OF THIS SOFTWARE                       *
C      *                                                     *
C      *******************************************************
C
C ARCHIVE ARGTYP.RAT              44   3-MAR-82 00:06:42
C argtyp - return flags for argument types in defn
C	 - caution this routine modifies defn!!!
      INTEGER FUNCTION ARGTYP(DEFN)
      INTEGER DEFN(*)
      INTEGER ATYPE, I, J, N, FOUND(10), SET, INDEXX, ISSET
      INTEGER DIGITS(11)
      DATA DIGITS(1)/48/,DIGITS(2)/49/,DIGITS(3)/50/,DIGITS(4)/51/,DIGIT
     *S(5)/52/,DIGITS(6)/53/,DIGITS(7)/54/,DIGITS(8)/55/,DIGITS(9)/56/,D
     *IGITS(10)/57/,DIGITS(11)/0/
      DO 2000 I = 1, 10
        FOUND(I) = 0
2000  CONTINUE
      ATYPE = 0
      I = 1
      DO WHILE (DEFN(I) .NE. 0)
        IF (DEFN(I) .EQ. 36 .OR. DEFN(I) .EQ. 37) THEN
          N = INDEXX(DIGITS, DEFN(I + 1))
          IF (DEFN(I+1) .EQ. 38) THEN
            IF (ISSET(ATYPE, 11) .EQ. 0) THEN
              DO 2050 J = 1, 10
                IF (FOUND(J) .NE. 0) THEN
                  CALL SYNERR('arguments cannot be both numeric and & ty
     *pes.')
                  GOTO 2030
                END IF
2050          CONTINUE
              ATYPE = SET(ATYPE, 11)
            END IF
            N = 2
          END IF
          IF (N .NE. 0) THEN
            ATYPE = SET(ATYPE, 10)
            IF (DEFN(I+1) .NE. 38 .AND. ISSET(ATYPE, 11) .EQ. 1) THEN
              CALL SYNERR('arguments cannot be both numeric and & types.
     *')
              N = 2
            ELSE IF (FOUND(N) .NE. 0 .AND. FOUND(N) .NE. DEFN(I)) THEN
              CALL SYNERR('argument cannot be both eval type and noeval 
     *type.')
            ELSE
              FOUND(N) = DEFN(I)
              IF (DEFN(I) .EQ. 37) THEN
                ATYPE = SET(ATYPE, N - 1)
              END IF
            END IF
            DEFN(I) = 36
            DEFN(I + 1) = DIGITS(N)
          END IF
        END IF
2030    I = I + 1
      END DO
      ARGTYP = (ATYPE)
      RETURN
      END
C ARCHIVE DEFTOK.RAT             134   3-FEB-82 11:26:59
C deftok - get token, process macro invocations
      INTEGER FUNCTION DEFTOK(TOKEN, TOKSIZ)
      INTEGER TOKEN(*), DEFN(500)
C Modif NB
      INTEGER CC
      INTEGER J, NLB, TOKSIZ, ARGTY
      INTEGER GTOKEN
      INTEGER LOOKUP, PUSH, LENGTH, ISSET, NOEVAL
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
C--------------------------------------------------------------------
C# preprocessor common block to hold definitions
C put on a file named 'clook'
C Used by ratfiv preprocessor, macro, and form tools
      COMMON/CLOOK/AVAIL, TABPTR(127), TABLE(10001)
Cfirst location in table; init = 1
      INTEGER AVAIL
Cname poiners; init = 0
      INTEGER TABPTR
Cactual text of names and definitions
      INTEGER TABLE
C----------------------------------------------------------------------
C preprocessor common block to hold input characters
C Put on a file called 'cdefio'
C Used by ratfiv preprocessor and macro
      COMMON/CDEFIO/BP, BPLOW, BPSAVE(4), BUF(900)
C next available character; init = 0
      INTEGER BP
C bottom of push-back buffer at current file level
      INTEGER BPLOW
C holds bplow for active file levels
      INTEGER BPSAVE
C pushed-back characters
      INTEGER BUF
C-----------------------------------------------------------------------
C preprocessor common block to hold info about lines and included files
C put on a file named 'cline'
C used by ratfiv preproccessor and macro
      COMMON/CLINE/LEVEL, INFILE(4), LINECT(4), FNAMP(4), FNAMES(920), I
     *OIN(134)
C level of file inclusion; init = 1
      INTEGER LEVEL
C file number(level); init infile(1) = STDIN
      INTEGER INFILE
C line count on input file(level); init = 1
      INTEGER LINECT
C next free slot in fnames
      INTEGER FNAMP
C stack of open file names
      INTEGER FNAMES
C input buffer
      INTEGER IOIN
      INTEGER BALP(3)
      DATA BALP(1)/40/,BALP(2)/41/,BALP(3)/0/
2070  DO WHILE (LEVEL .GT. 0 .OR. BP .GT. BPLOW)
        DEFTOK = GTOKEN(TOKEN, TOKSIZ)
        DO WHILE (DEFTOK .NE. -10)
          IF (DEFTOK .EQ. 1) THEN
            IF (LOOKUP(TOKEN, DEFN, ARGTY) .EQ. 0) THEN
              IF (CP .EQ. 0) THEN
                IF (DEFSTK(DEFCNT)) THEN
                  RETURN
                END IF
              ELSE
                CALL PUTTOK(TOKEN)
              END IF
            ELSE IF (NOEVAL(CP, AP, CALLST, ARGSTK) .EQ. 1) THEN
              CALL PUTTOK(TOKEN)
            ELSE
C defined; put it in eval stack
              CP = CP + 1
              IF (CP .GT. 30) THEN
                CALL FATAL('call stack overflow.')
              END IF
              CALLST(CP) = AP
              AP = PUSH(ARGTY, ARGSTK, AP)
              AP = PUSH(EP, ARGSTK, AP)
C stack definition
              CALL PUTTOK(DEFN)
              CC = 0
              CALL PUTCHR(CC)
              AP = PUSH(EP, ARGSTK, AP)
C stack name
              CALL PUTTOK(TOKEN)
              CC = 0
              CALL PUTCHR(CC)
              AP = PUSH(EP, ARGSTK, AP)
              IF (ISSET(ARGTY, 10) .EQ. 1) THEN
                J = 0
2120            CONTINUE
C peek at next
                  DEFTOK = GTOKEN(TOKEN, TOKSIZ)
                  J = J + 1
2130            IF (.NOT.(DEFTOK .NE. 32)) GOTO 2120
                CALL PBSTR(TOKEN)
                IF (DEFTOK .NE. 40) THEN
C add ( ) if not present
                  DO WHILE (J .GT. 1)
                    CC = 32
                    CALL PUTBAK(CC)
2160                J = J - 1
                  END DO
                  CALL PBSTR(BALP)
                END IF
              ELSE
                CALL PBSTR(BALP)
              END IF
              PLEV(CP) = 0
            END IF
          ELSE IF (CP .EQ. 0) THEN
C not in a macro at all
            IF (DEFSTK(DEFCNT)) THEN
              RETURN
            END IF
          ELSE IF (DEFTOK .EQ. 40) THEN
            IF (PLEV(CP) .GT. 0) THEN
              CALL PUTTOK(TOKEN)
            END IF
            PLEV(CP) = PLEV(CP) + 1
          ELSE IF (DEFTOK .EQ. 41) THEN
            PLEV(CP) = PLEV(CP) - 1
            IF (PLEV(CP) .GT. 0) THEN
              CALL PUTTOK(TOKEN)
            ELSE
C end of argument list
              CC = 0
              CALL PUTCHR(CC)
              CALL EVAL(CALLST(CP) + 1, CALLST(CP) + 2, AP - CALLST(CP) 
     *- 3)
C pop eval stack
              AP = CALLST(CP)
              EP = ARGSTK(AP + 1)
              CP = CP - 1
            END IF
          ELSE IF (DEFTOK .EQ. 44 .AND. PLEV(CP) .EQ. 1) THEN
C new argument
            IF (ISSET(ARGSTK(CALLST(CP)), 11) .EQ. 1) THEN
C allow commas in argument
              CALL PUTTOK(TOKEN)
            ELSE
              CC = 0
              CALL PUTCHR(CC)
              IF (AP-CALLST(CP)-3 .GE. 9) THEN
                CALL SYNERR('too many arguments passed to a macro.')
              ELSE
                AP = PUSH(EP, ARGSTK, AP)
              END IF
            END IF
          ELSE
C just stack it
            CALL PUTTOK(TOKEN)
          END IF
2100      DEFTOK = GTOKEN(TOKEN, TOKSIZ)
        END DO
        IF (LEVEL .GT. 0) THEN
          IF (INFILE(LEVEL) .NE. 5) THEN
C here on EOF; pop back to last file
            CALL CLOSE(INFILE(LEVEL))
          END IF
C restore bottom of push-back buffer
          BPLOW = BPSAVE(LEVEL)
          LEVEL = LEVEL - 1
        END IF
      END DO
      IF (CP .NE. 0 .OR. DEFCNT .GT. 1) THEN
        CALL SYNERR('unexpected EOF.')
      END IF
C in case called at EOF
      DEFTOK =  - 10
      TOKEN(1) =  - 10
      TOKEN(2) = 0
      RETURN
      END
C ARCHIVE DOARTH.RAT              30  30-NOV-81 14:32:08
C doarth - arithmetic interpreter
      SUBROUTINE DOARTH(IARGS, NARGS)
      INTEGER IARGS, NARGS
      INTEGER CTOI
      INTEGER K, OP1, OP2, A
      INTEGER OP
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (NARGS .GT. 0) THEN
        A = ARGSTK(IARGS + 1)
        OP1 = CTOI(EVALST, A)
        K = 2
        DO WHILE (K+1 .LE. NARGS)
          OP = EVALST(ARGSTK(IARGS + K))
          A = ARGSTK(IARGS + K + 1)
          OP2 = CTOI(EVALST, A)
          IF (OP .EQ. 43) THEN
            OP1 = OP1 + OP2
          ELSE IF (OP .EQ. 45) THEN
            OP1 = OP1 - OP2
          ELSE IF (OP .EQ. 42) THEN
            OP1 = OP1*OP2
          ELSE IF (OP .EQ. 47 .AND. OP2 .NE. 0) THEN
            OP1 = OP1/OP2
          ELSE
            CALL SYNERR('arith error.')
          END IF
2190      K = K + 2
        END DO
      END IF
      CALL PBNUM(OP1)
      RETURN
      END
C ARCHIVE DODEF.RAT               32  30-NOV-81 14:32:09
C dodef - install definition in table
      SUBROUTINE DODEF(IARGS, NARGS)
      INTEGER A1, IARGS, NARGS, ARGTYP, I
      INTEGER C, NGETCH, TYPE
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (NARGS .GE. 1) THEN
        A1 = ARGSTK(IARGS + 1)
        I = 0
2210    CONTINUE
          IF (TYPE(EVALST(A1+I)) .NE. 3 .AND. EVALST(A1+I) .NE. 95 .AND.
     * EVALST(A1+I) .NE. 36 .AND. (I .EQ. 0 .OR. TYPE(EVALST(A1+I)) .NE.
     * 2)) THEN
            CALL ERRLIN(EVALST(A1))
            CALL SYNERR('illegal macro name.')
            GOTO 10
          END IF
          I = I + 1
2220    IF (.NOT.(EVALST(A1+I) .EQ. 44 .OR. EVALST(A1+I) .EQ. 0)) GOTO 2
     *210
        IF (EVALST(A1+I) .NE. 0) THEN
          EVALST(A1 + I) = 0
          CALL INSTAL(EVALST(A1), EVALST(A1 + I + 1), ARGTYP(EVALST(A1 +
     * I + 1)))
        ELSE
          CALL INSTAL(EVALST(A1), 0, 0)
        END IF
      END IF
10    IF (NGETCH(C) .NE. 10) THEN
        CALL PUTBAK(C)
      END IF
      RETURN
      END
C ARCHIVE DOELSD.RAT              13  30-NOV-81 14:32:09
C doelsd - handle _elsedef
      SUBROUTINE DOELSD
      INTEGER C, NGETCH
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (DEFCNT .LE. 1) THEN
        CALL SYNERR('bad _elsedef.')
      ELSE
        DEFSTK(DEFCNT) = DEFSTK(DEFCNT - 1) .AND. .NOT.DEFSTK(DEFCNT)
      END IF
      IF (NGETCH(C) .NE. 10) THEN
        CALL PUTBAK(C)
      END IF
      RETURN
      END
C ARCHIVE DOENDD.RAT              13  30-NOV-81 14:32:09
C doendd - handle _enddef
      SUBROUTINE DOENDD
      INTEGER C, NGETCH
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (DEFCNT .LE. 1) THEN
        CALL SYNERR('bad _enddef.')
      ELSE
        DEFCNT = DEFCNT - 1
      END IF
      IF (NGETCH(C) .NE. 10) THEN
        CALL PUTBAK(C)
      END IF
      RETURN
      END
C ARCHIVE DOIF.RAT                14  30-NOV-81 14:32:09
C doif - select one of two (macro) arguments    /*/sor/macror/doif
      SUBROUTINE DOIF(IARGS, NARGS)
      INTEGER EQUAL
      INTEGER IARGS, NARGS
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (NARGS .LT. 3) THEN
        RETURN
      END IF
      IF (EQUAL(EVALST(ARGSTK(IARGS+1)), EVALST(ARGSTK(IARGS+2))) .EQ. 1
     *) THEN
C subarrays
        CALL PBSTR(EVALST(ARGSTK(IARGS + 3)))
      ELSE IF (NARGS .GE. 4) THEN
        CALL PBSTR(EVALST(ARGSTK(IARGS + 4)))
      END IF
      RETURN
      END
C ARCHIVE DOIFD.RAT               18  30-NOV-81 14:32:09
C doifd - do ifdef builtin macro
      SUBROUTINE DOIFD(IARGS, NARGS)
      INTEGER IARGS, NARGS, LOCDEF, JUNK1, JUNK2
      INTEGER C, NGETCH
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      DEFCNT = DEFCNT + 1
      IF (DEFCNT .GT. 20) THEN
        CALL FATAL('_ifdefs nested too deeply.')
      END IF
      DEFSTK(DEFCNT) = DEFSTK(DEFCNT - 1)
      IF (DEFSTK(DEFCNT)) THEN
        IF (NARGS .GT. 0) THEN
          IF (LOCDEF(EVALST(ARGSTK(IARGS+1)), JUNK1, JUNK2, C) .NE. 1) T
     *HEN
            DEFSTK(DEFCNT) = .FALSE.
          END IF
        END IF
      END IF
      IF (NGETCH(C) .NE. 10) THEN
        CALL PUTBAK(C)
      END IF
      RETURN
      END
C ARCHIVE DOINCL.RAT              12   1-DEC-81 11:46:04
C doincl - handle file inclusion for macro
      SUBROUTINE DOINCL(IARGS, NARGS)
      INTEGER IARGS, NARGS
      INTEGER NGETCH, C
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
C-----------------------------------------------------------------------
C preprocessor common block to hold info about lines and included files
C put on a file named 'cline'
C used by ratfiv preproccessor and macro
      COMMON/CLINE/LEVEL, INFILE(4), LINECT(4), FNAMP(4), FNAMES(920), I
     *OIN(134)
C level of file inclusion; init = 1
      INTEGER LEVEL
C file number(level); init infile(1) = STDIN
      INTEGER INFILE
C line count on input file(level); init = 1
      INTEGER LINECT
C next free slot in fnames
      INTEGER FNAMP
C stack of open file names
      INTEGER FNAMES
C input buffer
      INTEGER IOIN
      IF (NGETCH(C) .NE. 10) THEN
        CALL PUTBAK(C)
      END IF
      CALL INCLUD(EVALST(ARGSTK(IARGS + 1)))
      RETURN
      END
C ARCHIVE DOINCR.RAT              12  30-NOV-81 14:32:10
C doincr - increment macro argument by 1
      SUBROUTINE DOINCR(IARGS, NARGS)
      INTEGER CTOI
      INTEGER IARGS, NARGS, K
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (NARGS .NE. 0) THEN
        K = ARGSTK(IARGS + 1)
        CALL PBNUM(CTOI(EVALST, K) + 1)
      END IF
      RETURN
      END
C ARCHIVE DOIND.RAT               12  30-NOV-81 14:32:10
C doind - get index of arg2 in arg1
      SUBROUTINE DOIND(IARGS, NARGS)
      INTEGER IARGS, NARGS
      INTEGER INDEXX
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (NARGS .EQ. 1) THEN
        CALL PBNUM(0)
      ELSE IF (NARGS .GE. 2) THEN
        CALL PBNUM(INDEXX(EVALST(ARGSTK(IARGS + 1)), EVALST(ARGSTK(IARGS
     * + 2))))
      END IF
      RETURN
      END
C ARCHIVE DOLEN.RAT               12  30-NOV-81 14:32:10
C dolen - get length of argument
      SUBROUTINE DOLEN(IARGS, NARGS)
      INTEGER IARGS, NARGS
      INTEGER LENGTH
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (NARGS .LT. 1) THEN
        CALL PBNUM(0)
      ELSE
        CALL PBNUM(LENGTH(EVALST(ARGSTK(IARGS + 1))))
      END IF
      RETURN
      END
C ARCHIVE DOSUB.RAT               29  30-NOV-81 14:32:10
C dosub - select macro substring
      SUBROUTINE DOSUB(IARGS, NARGS)
      INTEGER CTOI, LENGTH
      INTEGER AP1, FC, IARGS, NARGS, K, NC, BS
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (NARGS .EQ. 0) THEN
        RETURN
      END IF
      IF (NARGS .EQ. 1) THEN
        BS = 1
      ELSE
        K = ARGSTK(IARGS + 2)
        BS = CTOI(EVALST, K)
      END IF
      IF (NARGS .LE. 2) THEN
        NC = 32767
      ELSE
        K = ARGSTK(IARGS + 3)
C number of characters
        NC = CTOI(EVALST, K)
      END IF
C target string
      AP1 = ARGSTK(IARGS + 1)
C first char of substring
      FC = AP1 + BS - 1
      IF (FC .GE. AP1 .AND. FC .LT. AP1+LENGTH(EVALST(AP1))) THEN
C subarrays
        K = FC + MIN0(NC, LENGTH(EVALST(FC))) - 1
        DO WHILE (K .GE. FC)
          CALL PUTBAK(EVALST(K))
2250      K = K - 1
        END DO
      END IF
      RETURN
      END
C ARCHIVE DOUND.RAT               17  30-NOV-81 14:32:11
C dound - undefine a macro and garbage collect
      SUBROUTINE DOUND(IARGS, NARGS)
      INTEGER IARGS, NARGS, A1, I, INDEXX
      INTEGER NGETCH, C
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (NARGS .GE. 1) THEN
        A1 = ARGSTK(IARGS + 1)
        I = INDEXX(EVALST(A1), 44)
        IF (I .NE. 0) THEN
          EVALST(A1 + I - 1) = 0
        END IF
        CALL UNDEF(EVALST(A1))
      END IF
      IF (NGETCH(C) .NE. 10) THEN
        CALL PUTBAK(C)
      END IF
      RETURN
      END
C ARCHIVE ERRLIN.RAT              12  30-NOV-81 14:32:11
C errlin - save a string to output to STDOUT and to ERROUT
      SUBROUTINE ERRLIN(MESS)
      INTEGER MESS(*)
      INTEGER I, J, LENGTH
C cerrbf - holds an error message for later output by synerr
      COMMON/CERRBF/ERRBUF(201)
      INTEGER ERRBUF
      J = LENGTH(ERRBUF)
      I = J + 1
      DO WHILE (I .LT. 201 .AND. MESS(I-J) .NE. 0)
        ERRBUF(I) = MESS(I - J)
2280    I = I + 1
      END DO
      ERRBUF(I) = 0
      RETURN
      END
C ARCHIVE EVAL.RAT                63   4-DEC-81 13:25:18
C eval - expand args: evaluate builtin or push back defn
      SUBROUTINE EVAL(IDEFN, IARGS, NARGS)
      INTEGER INDEXX, LENGTH
      INTEGER ARGNO, IDEFN, IARGS, NARGS, K, T, TD
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      INTEGER DIGITS(11)
      DATA DIGITS(1)/48/,DIGITS(2)/49/,DIGITS(3)/50/,DIGITS(4)/51/,DIGIT
     *S(5)/52/,DIGITS(6)/53/,DIGITS(7)/54/,DIGITS(8)/55/,DIGITS(9)/56/,D
     *IGITS(10)/57/,DIGITS(11)/0/
      T = ARGSTK(IDEFN)
      TD = EVALST(T)
      IF (TD .LT. 0) THEN
        IF (TD .EQ. -27) THEN
          CALL DOIFD(IARGS, NARGS)
        ELSE IF (TD .EQ. -28) THEN
          CALL DOELSD
        ELSE IF (TD .EQ. -29) THEN
          CALL DOENDD
        ELSE IF (TD .EQ. -22) THEN
          CALL DOINCR(IARGS, NARGS)
        ELSE IF (TD .EQ. -23) THEN
          CALL DOSUB(IARGS, NARGS)
        ELSE IF (TD .EQ. -21) THEN
          CALL DOIF(IARGS, NARGS)
        ELSE IF (TD .EQ. -24) THEN
          CALL DOARTH(IARGS, NARGS)
        ELSE IF (TD .EQ. -25) THEN
          CALL DOLEN(IARGS, NARGS)
        ELSE IF (TD .EQ. -26) THEN
          CALL DOIND(IARGS, NARGS)
        ELSE IF (TD .EQ. -30) THEN
          IF (DEFSTK(DEFCNT)) THEN
            CALL DOINCL(IARGS, NARGS)
          END IF
        ELSE IF (TD .EQ. -20) THEN
          IF (DEFSTK(DEFCNT)) THEN
            CALL DODEF(IARGS, NARGS)
          END IF
        ELSE IF (TD .EQ. -31) THEN
          IF (DEFSTK(DEFCNT)) THEN
            CALL DOUND(IARGS, NARGS)
          END IF
C just pass it along
        ELSE
          CALL PUTBAK(EVALST(T))
        END IF
      ELSE
        K = T + LENGTH(EVALST(T)) - 1
        DO WHILE (K .GT. T)
          IF (EVALST(K-1) .NE. 36) THEN
            CALL PUTBAK(EVALST(K))
          ELSE
            ARGNO = INDEXX(DIGITS, EVALST(K)) - 1
            IF (ARGNO .GE. 0 .AND. ARGNO .LE. NARGS) THEN
              CALL PBSTR(EVALST(ARGSTK(IARGS + ARGNO)))
C skip over $
              K = K - 1
            ELSE IF (ARGNO .EQ. -1) THEN
C wasn't a digit
              CALL PUTBAK(EVALST(K))
            ELSE
C skip over $
              K = K - 1
            END IF
          END IF
2310      K = K - 1
        END DO
        IF (K .EQ. T) THEN
C do last character
          CALL PUTBAK(EVALST(K))
        END IF
      END IF
      RETURN
      END
C ARCHIVE FATAL.RAT                8  30-NOV-81 14:32:11
C fatal - handle fatal error
      SUBROUTINE FATAL(MESS)
      CHARACTER MESS*(*)
C Modif
      INTEGER CC
      CALL SYNERR(MESS)
      CC = 0
      CALL ERROR(CC)
      RETURN
      END
C ARCHIVE GETINT.RAT              11  30-NOV-81 14:32:12
C getint - get an integer from table
      INTEGER FUNCTION GETINT(TABLE)
      INTEGER TABLE(4), C(4)
      INTEGER I, J
      EQUIVALENCE(I, C)
      DO 2330 J = 1, 4
        C(J) = TABLE(J)
2330  CONTINUE
      GETINT = I
      RETURN
      END
C ARCHIVE GTOKENM.RAT             42  30-NOV-81 14:32:12
C ARCHIVE INCLUD.RAT              26   1-DEC-81 11:47:48
C includ - handle file inclusion
      SUBROUTINE INCLUD(FILE)
      INTEGER FILE(*)
      INTEGER LENGTH, OPEN
C-----------------------------------------------------------------------
C preprocessor common block to hold info about lines and included files
C put on a file named 'cline'
C used by ratfiv preproccessor and macro
      COMMON/CLINE/LEVEL, INFILE(4), LINECT(4), FNAMP(4), FNAMES(920), I
     *OIN(134)
C level of file inclusion; init = 1
      INTEGER LEVEL
C file number(level); init infile(1) = STDIN
      INTEGER INFILE
C line count on input file(level); init = 1
      INTEGER LINECT
C next free slot in fnames
      INTEGER FNAMP
C stack of open file names
      INTEGER FNAMES
C input buffer
      INTEGER IOIN
C----------------------------------------------------------------------
C preprocessor common block to hold input characters
C Put on a file called 'cdefio'
C Used by ratfiv preprocessor and macro
      COMMON/CDEFIO/BP, BPLOW, BPSAVE(4), BUF(900)
C next available character; init = 0
      INTEGER BP
C bottom of push-back buffer at current file level
      INTEGER BPLOW
C holds bplow for active file levels
      INTEGER BPSAVE
C pushed-back characters
      INTEGER BUF
      IF (LEVEL .GE. 4) THEN
        CALL SYNERR('includes nested too deeply.')
      ELSE
        INFILE(LEVEL + 1) = OPEN(FILE, 114)
        IF (INFILE(LEVEL+1) .EQ. -1) THEN
          CALL ERRLIN(FILE)
          CALL SYNERR('can''t open included file.')
        ELSE
          LEVEL = LEVEL + 1
          LINECT(LEVEL) = 0
          FNAMP(LEVEL) = FNAMP(LEVEL - 1) + LENGTH(FNAMES(FNAMP(LEVEL - 
     *1))) + 1
          CALL SCOPY(FILE, 1, FNAMES, FNAMP(LEVEL))
          BPSAVE(LEVEL) = BPLOW
          BPLOW = BP
        END IF
      END IF
      RETURN
      END
C ARCHIVE INIMAC.RAT              82   3-MAR-82 00:02:51
C inimac - initialize macro preproccessor
      SUBROUTINE INIMAC
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
C--------------------------------------------------------------------
C# preprocessor common block to hold definitions
C put on a file named 'clook'
C Used by ratfiv preprocessor, macro, and form tools
      COMMON/CLOOK/AVAIL, TABPTR(127), TABLE(10001)
Cfirst location in table; init = 1
      INTEGER AVAIL
Cname poiners; init = 0
      INTEGER TABPTR
Cactual text of names and definitions
      INTEGER TABLE
C----------------------------------------------------------------------
C preprocessor common block to hold input characters
C Put on a file called 'cdefio'
C Used by ratfiv preprocessor and macro
      COMMON/CDEFIO/BP, BPLOW, BPSAVE(4), BUF(900)
C next available character; init = 0
      INTEGER BP
C bottom of push-back buffer at current file level
      INTEGER BPLOW
C holds bplow for active file levels
      INTEGER BPSAVE
C pushed-back characters
      INTEGER BUF
C cerrbf - holds an error message for later output by synerr
      COMMON/CERRBF/ERRBUF(201)
      INTEGER ERRBUF
      INTEGER SET, ARGTYP
      INTEGER MACNAM(7), MACTYP(2)
      INTEGER UNDNAM(7), UNDTYP(2)
      INTEGER INCNAM(6), INCTYP(2)
      INTEGER SUBNAM(8), SUBTYP(2)
      INTEGER IFENAM(8), IFETYP(2)
      INTEGER ARINAM(7), ARITYP(2)
      INTEGER LENNAM(5), LENTYP(2)
      INTEGER INDNAM(7), INDTYP(2)
      INTEGER IFDNAM(7), IFDTYP(2)
      INTEGER ELSNAM(9), ELSTYP(2)
      INTEGER ENDNAM(8), ENDTYP(2)
      INTEGER ICLNAM(9), ICLTYP(2)
      INTEGER IFNNAM(8)
      INTEGER IFNDEF(19)
      INTEGER IFNOTN(10)
      INTEGER IFNOTD(19)
      INTEGER REPNAM(8)
      INTEGER REPDEF(21)
      DATA IFNNAM(1)/95/,IFNNAM(2)/105/,IFNNAM(3)/102/,IFNNAM(4)/110/,IF
     *NNAM(5)/100/,IFNNAM(6)/101/,IFNNAM(7)/102/,IFNNAM(8)/0/
      DATA IFNDEF(1)/95/,IFNDEF(2)/105/,IFNDEF(3)/102/,IFNDEF(4)/100/,IF
     *NDEF(5)/101/,IFNDEF(6)/102/,IFNDEF(7)/40/,IFNDEF(8)/37/,IFNDEF(9)/
     *49/,IFNDEF(10)/41/,IFNDEF(11)/95/,IFNDEF(12)/101/,IFNDEF(13)/108/,
     *IFNDEF(14)/115/,IFNDEF(15)/101/,IFNDEF(16)/100/,IFNDEF(17)/101/,IF
     *NDEF(18)/102/,IFNDEF(19)/0/
      DATA IFNOTN(1)/95/,IFNOTN(2)/105/,IFNOTN(3)/102/,IFNOTN(4)/110/,IF
     *NOTN(5)/111/,IFNOTN(6)/116/,IFNOTN(7)/100/,IFNOTN(8)/101/,IFNOTN(9
     *)/102/,IFNOTN(10)/0/
      DATA IFNOTD(1)/95/,IFNOTD(2)/105/,IFNOTD(3)/102/,IFNOTD(4)/100/,IF
     *NOTD(5)/101/,IFNOTD(6)/102/,IFNOTD(7)/40/,IFNOTD(8)/37/,IFNOTD(9)/
     *49/,IFNOTD(10)/41/,IFNOTD(11)/95/,IFNOTD(12)/101/,IFNOTD(13)/108/,
     *IFNOTD(14)/115/,IFNOTD(15)/101/,IFNOTD(16)/100/,IFNOTD(17)/101/,IF
     *NOTD(18)/102/,IFNOTD(19)/0/
      DATA REPNAM(1)/95/,REPNAM(2)/114/,REPNAM(3)/101/,REPNAM(4)/112/,RE
     *PNAM(5)/100/,REPNAM(6)/101/,REPNAM(7)/102/,REPNAM(8)/0/
      DATA REPDEF(1)/95/,REPDEF(2)/117/,REPDEF(3)/110/,REPDEF(4)/100/,RE
     *PDEF(5)/101/,REPDEF(6)/102/,REPDEF(7)/40/,REPDEF(8)/37/,REPDEF(9)/
     *38/,REPDEF(10)/41/,REPDEF(11)/95/,REPDEF(12)/109/,REPDEF(13)/97/,R
     *EPDEF(14)/99/,REPDEF(15)/114/,REPDEF(16)/111/,REPDEF(17)/40/,REPDE
     *F(18)/37/,REPDEF(19)/38/,REPDEF(20)/41/,REPDEF(21)/0/
      DATA MACNAM/95, 109, 97, 99, 114, 111, 0/, MACTYP/ - 20, 0/
      DATA UNDNAM/95, 117, 110, 100, 101, 102, 0/, UNDTYP/ - 31, 0/
      DATA INCNAM/95, 105, 110, 99, 114, 0/, INCTYP/ - 22, 0/
      DATA SUBNAM/95, 115, 117, 98, 115, 116, 114, 0/, SUBTYP/ - 23, 0/
      DATA IFENAM/95, 105, 102, 101, 108, 115, 101, 0/, IFETYP/ - 21, 0/
      DATA ARINAM/95, 97, 114, 105, 116, 104, 0/, ARITYP/ - 24, 0/
      DATA LENNAM/95, 108, 101, 110, 0/, LENTYP/ - 25, 0/
      DATA INDNAM/95, 105, 110, 100, 101, 120, 0/, INDTYP/ - 26, 0/
      DATA IFDNAM/95, 105, 102, 100, 101, 102, 0/, IFDTYP/ - 27, 0/
      DATA ELSNAM/95, 101, 108, 115, 101, 100, 101, 102, 0/, ELSTYP/ - 2
     *8, 0/
      DATA ENDNAM/95, 101, 110, 100, 100, 101, 102, 0/, ENDTYP/ - 29, 0/
      DATA ICLNAM/95, 105, 110, 99, 108, 117, 100, 101, 0/, ICLTYP/ - 30
     *, 0/
      AVAIL = 1
      I = 1
      DO WHILE (I .LE. 127)
        TABPTR(I) = 0
2360    I = I + 1
      END DO
      CALL INSUPL(MACNAM, MACTYP, SET(SET(SET(0, 10), 11), 1))
      CALL INSUPL(UNDNAM, UNDTYP, SET(SET(SET(0, 10), 11), 1))
      CALL INSUPL(INCNAM, INCTYP, SET(0, 10))
      CALL INSUPL(SUBNAM, SUBTYP, SET(0, 10))
      CALL INSUPL(IFENAM, IFETYP, SET(SET(SET(0, 10), 3), 4))
      CALL INSUPL(ARINAM, ARITYP, SET(0, 10))
      CALL INSUPL(LENNAM, LENTYP, SET(SET(0, 10), 11))
      CALL INSUPL(INDNAM, INDTYP, SET(0, 10))
      CALL INSUPL(IFDNAM, IFDTYP, SET(SET(0, 10), 1))
      CALL INSUPL(ELSNAM, ELSTYP, 0)
      CALL INSUPL(ENDNAM, ENDTYP, 0)
      CALL INSUPL(ICLNAM, ICLTYP, SET(SET(0, 10), 11))
      CALL INSUPL(IFNNAM, IFNDEF, ARGTYP(IFNDEF))
      CALL INSUPL(IFNOTN, IFNOTD, ARGTYP(IFNOTD))
      CALL INSUPL(REPNAM, REPDEF, ARGTYP(REPDEF))
C initialize pointers, etc.
      BP = 0
      BPSAVE(1) = 0
      BPLOW = 0
      CP = 0
      AP = 1
      EP = 1
      DEFCNT = 1
      DEFSTK(1) = .TRUE.
      ERRBUF(1) = 0
      RETURN
      END
C ARCHIVE INSTAL.RAT              30  30-NOV-81 14:32:12
C instal - add name and definition to table
      SUBROUTINE INSTAL(NAME, DEFN, FLAG)
      INTEGER DEFN(500), NAME(201), C
      INTEGER LENGTH
      INTEGER DLEN, NLEN, FLAG
C--------------------------------------------------------------------
C# preprocessor common block to hold definitions
C put on a file named 'clook'
C Used by ratfiv preprocessor, macro, and form tools
      COMMON/CLOOK/AVAIL, TABPTR(127), TABLE(10001)
Cfirst location in table; init = 1
      INTEGER AVAIL
Cname poiners; init = 0
      INTEGER TABPTR
Cactual text of names and definitions
      INTEGER TABLE
      IF (NAME(1) .NE. 0) THEN
        NLEN = LENGTH(NAME) + 1
        DLEN = LENGTH(DEFN) + 1
        IF (DLEN .GT. 500) THEN
          CALL ERRLIN(NAME)
          CALL SYNERR('definition too long.')
          RETURN
        END IF
        IF (AVAIL+NLEN+DLEN+2*4 .GT. 10001+1) THEN
          CALL ERRLIN(NAME)
          CALL FATAL('too many definitions.')
          RETURN
        END IF
        CALL SETINT(TABLE(AVAIL + 4), FLAG)
        CALL SCOPY(NAME, 1, TABLE, AVAIL + 2*4)
        CALL SCOPY(DEFN, 1, TABLE, AVAIL + NLEN + 2*4)
        C = TABLE(AVAIL + 2*4)
        CALL SETINT(TABLE(AVAIL), TABPTR(C))
        TABPTR(C) = AVAIL
        AVAIL = AVAIL + NLEN + DLEN + 2*4
      END IF
      RETURN
      END
C ARCHIVE INSUPL.RAT              11  30-NOV-81 14:32:13
C insupl - install upper and lower case versions of name
      SUBROUTINE INSUPL(NAME, DEFN, FLAG)
      INTEGER NAME(201), DEFN(500), FNAME(201)
      INTEGER FLAG
      CALL INSTAL(NAME, DEFN, FLAG)
      CALL SCOPY(NAME, 1, FNAME, 1)
      CALL UPPER(FNAME)
      CALL INSTAL(FNAME, DEFN, FLAG)
      RETURN
      END
C ARCHIVE ISSET.RAT               11  30-NOV-81 14:32:13
C isset - return YES if bit n is set in flags
      INTEGER FUNCTION ISSET(FLAGS, N)
      INTEGER FLAGS, N
      INTEGER BITMSK(12)
      DATA BITMSK/1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048/
      ISSET = 0
      IF (MOD(FLAGS/BITMSK(N+1), 2) .EQ. 1) THEN
        ISSET = 1
      END IF
      RETURN
      END
C ARCHIVE LOCDEF.RAT              23   3-FEB-82 23:24:23
C locdef - locate name
      INTEGER FUNCTION LOCDEF(NAME, I, J, C)
      INTEGER NAME(201), C
      INTEGER I, J, K
      INTEGER GETINT
C--------------------------------------------------------------------
C# preprocessor common block to hold definitions
C put on a file named 'clook'
C Used by ratfiv preprocessor, macro, and form tools
      COMMON/CLOOK/AVAIL, TABPTR(127), TABLE(10001)
Cfirst location in table; init = 1
      INTEGER AVAIL
Cname poiners; init = 0
      INTEGER TABPTR
Cactual text of names and definitions
      INTEGER TABLE
      IF (NAME(1) .NE. 0) THEN
        C = NAME(1)
        I = TABPTR(C)
        DO WHILE (I .GT. 0)
          J = I + 2*4
          K = 1
          DO WHILE (NAME(K) .EQ. TABLE(J) .AND. NAME(K) .NE. 0)
            J = J + 1
2420        K = K + 1
          END DO
          IF (NAME(K) .EQ. TABLE(J)) THEN
C got one
            J = J + 1
            LOCDEF = 1
            RETURN
          END IF
2390      I = GETINT(TABLE(I))
        END DO
      END IF
      LOCDEF = 0
      RETURN
      END
C ARCHIVE LOOKUP.RAT              13  30-NOV-81 14:32:13
C lookup - locate name, extract definition from table
      INTEGER FUNCTION LOOKUP(NAME, DEFN, FLAG)
      INTEGER DEFN(500), NAME(201), C
      INTEGER FLAG, I, J, LOCDEF, GETINT
C--------------------------------------------------------------------
C# preprocessor common block to hold definitions
C put on a file named 'clook'
C Used by ratfiv preprocessor, macro, and form tools
      COMMON/CLOOK/AVAIL, TABPTR(127), TABLE(10001)
Cfirst location in table; init = 1
      INTEGER AVAIL
Cname poiners; init = 0
      INTEGER TABPTR
Cactual text of names and definitions
      INTEGER TABLE
      LOOKUP = LOCDEF(NAME, I, J, C)
      IF (LOOKUP .EQ. 1) THEN
        CALL SCOPY(TABLE, J, DEFN, 1)
        FLAG = GETINT(TABLE(I + 4))
      END IF
      RETURN
      END
C ARCHIVE MACMAIN.RAT             50   1-DEC-81 11:26:17
C ARCHIVE NGETCH.RAT              35   3-FEB-82 13:22:38
C ngetch - get a (possibly pushed back) character
      INTEGER FUNCTION NGETCH(C)
      INTEGER C
CModif NB Dec 95
      INTEGER NBUF(7)
      INTEGER I, GETLIN
C----------------------------------------------------------------------
C preprocessor common block to hold input characters
C Put on a file called 'cdefio'
C Used by ratfiv preprocessor and macro
      COMMON/CDEFIO/BP, BPLOW, BPSAVE(4), BUF(900)
C next available character; init = 0
      INTEGER BP
C bottom of push-back buffer at current file level
      INTEGER BPLOW
C holds bplow for active file levels
      INTEGER BPSAVE
C pushed-back characters
      INTEGER BUF
C-----------------------------------------------------------------------
C preprocessor common block to hold info about lines and included files
C put on a file named 'cline'
C used by ratfiv preproccessor and macro
      COMMON/CLINE/LEVEL, INFILE(4), LINECT(4), FNAMP(4), FNAMES(920), I
     *OIN(134)
C level of file inclusion; init = 1
      INTEGER LEVEL
C file number(level); init infile(1) = STDIN
      INTEGER INFILE
C line count on input file(level); init = 1
      INTEGER LINECT
C next free slot in fnames
      INTEGER FNAMP
C stack of open file names
      INTEGER FNAMES
C input buffer
      INTEGER IOIN
2440  CONTINUE
        IF (BP .LE. BPLOW) THEN
          IF (LEVEL .GT. 0) THEN
            I = GETLIN(IOIN, INFILE(LEVEL))
          ELSE
            I =  - 10
          END IF
          IF (I .EQ. -10) THEN
            C =  - 10
            NGETCH = (C)
            RETURN
          END IF
          LINECT(LEVEL) = LINECT(LEVEL) + 1
C      call putlin('# ',ERROUT)  # Modif NB Dec 95
C      call itoc(linect(level), nbuf, MAXCHARS) # Modif NB Dec 95
C      call putlin(nbuf, ERROUT) # Modif NB Dec 95
C      call putlin(' "',ERROUT)  # Modif NB Dec 95
C      call putlin(fnames,ERROUT)  # Modif NB Dec 95
C      call remark('"')  # Modif NB Dec 95
2470      CONTINUE
C push ioin on pushback buffer
            BP = BP + 1
            BUF(BP) = IOIN(I)
            I = I - 1
2480      IF (.NOT.(I .EQ. 0)) GOTO 2470
        END IF
        C = BUF(BP)
        BP = BP - 1
        IF (C .EQ. 95) THEN
          IF (BP .GT. BPLOW) THEN
            IF (BUF(BP) .EQ. 10) THEN
              BP = BP - 1
              GOTO 2450
            END IF
          END IF
        END IF
        NGETCH = (C)
        RETURN
2450  GOTO 2440
      END
C ARCHIVE NOEVAL.RAT               9  30-NOV-81 14:32:14
C noeval - check if macro arguments should be evaluated now
      INTEGER FUNCTION NOEVAL(CP, AP, CALLST, ARGSTK)
      INTEGER CP, AP, CALLST(*), ARGSTK(*), ISSET
      NOEVAL = 0
      IF (CP .NE. 0) THEN
        NOEVAL = ISSET(ARGSTK(CALLST(CP)), AP - CALLST(CP) - 3)
      END IF
      RETURN
      END
C ARCHIVE PBNUM.RAT                9  30-NOV-81 14:32:14
C pbnum - convert number to string, push back on input
      SUBROUTINE PBNUM(N)
      INTEGER N, I, ITOC
      INTEGER STR(7)
      I = ITOC(N, STR, 7)
      CALL PBSTR(STR)
      RETURN
      END
C ARCHIVE PBSTR.RAT               10  30-NOV-81 14:32:14
C pbstr - push string back onto input
      SUBROUTINE PBSTR(IN)
      INTEGER IN(*)
      INTEGER LENGTH
      INTEGER I
      I = LENGTH(IN)
      DO WHILE (I .GT. 0)
        CALL PUTBAK(IN(I))
2510    I = I - 1
      END DO
      RETURN
      END
C ARCHIVE PUSH.RAT                10  30-NOV-81 14:32:15
C push - push ep onto argstk, return new pointer ap   /*/sor/macror/push
      INTEGER FUNCTION PUSH(EP, ARGSTK, AP)
      INTEGER AP, ARGSTK(120), EP
      IF (AP .GT. 120) THEN
        CALL FATAL('argument stack overflow.')
      END IF
      ARGSTK(AP) = EP
      PUSH = AP + 1
      RETURN
      END
C ARCHIVE PUTBAK.RAT              11   1-DEC-81 09:29:28
C putbak - push character back onto input
      SUBROUTINE PUTBAK(C)
      INTEGER C
C----------------------------------------------------------------------
C preprocessor common block to hold input characters
C Put on a file called 'cdefio'
C Used by ratfiv preprocessor and macro
      COMMON/CDEFIO/BP, BPLOW, BPSAVE(4), BUF(900)
C next available character; init = 0
      INTEGER BP
C bottom of push-back buffer at current file level
      INTEGER BPLOW
C holds bplow for active file levels
      INTEGER BPSAVE
C pushed-back characters
      INTEGER BUF
      BP = BP + 1
      IF (BP .GT. 900) THEN
        CALL FATAL('too many characters pushed back.')
      END IF
      BUF(BP) = C
      RETURN
      END
C ARCHIVE PUTCHR.RAT              11  30-NOV-81 14:32:15
C putchr - put single char into eval stack
      SUBROUTINE PUTCHR(C)
      INTEGER C
C -cmacro- common block
C put on a file called 'cmacro'
C Used only by the macro tool
      COMMON/CMACRO/CP, EP, EVALST(500), DEFCNT, DEFSTK(20), AP, ARGSTK(
     *120), CALLST(30), PLEV(30)
C current call stack pointer
      INTEGER CP
C next free position in evalst
      INTEGER EP
C evaluation stack
      INTEGER EVALST
C depth of _ifdef nesting Modif NB was logical?
      INTEGER DEFCNT
C remembers status of _ifdef levels
      LOGICAL DEFSTK
C pointer to next available space in argstk
      INTEGER AP
C pointers to evalst
      INTEGER ARGSTK
C points to invocation frames in argstk
      INTEGER CALLST
C parenthesis level at current invocation frame
      INTEGER PLEV
      IF (EP .GT. 500) THEN
        CALL FATAL('evaluation stack overflow.')
      END IF
      EVALST(EP) = C
      EP = EP + 1
      RETURN
      END
C ARCHIVE PUTTOK.RAT               9   3-DEC-81 09:35:40
C puttok - put token into eval stack
      SUBROUTINE PUTTOK(STR)
      INTEGER STR(201)
      INTEGER I
      I = 1
      DO WHILE (STR(I) .NE. 0)
        CALL PUTCHR(STR(I))
2540    I = I + 1
      END DO
      RETURN
      END
C ARCHIVE SET.RAT                 11  30-NOV-81 14:32:15
C set - return flags with bit n set
      INTEGER FUNCTION SET(FLAGS, N)
      INTEGER FLAGS, N
      INTEGER BITMSK(12), ISSET
      DATA BITMSK/1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048/
      SET = FLAGS
      IF (ISSET(FLAGS, N) .NE. 1) THEN
        SET = FLAGS + BITMSK(N + 1)
      END IF
      RETURN
      END
C ARCHIVE SETINT.RAT               8  30-NOV-81 14:32:16
C setint - put an integer into table
      SUBROUTINE SETINT(TABLE, VAL)
      INTEGER TABLE(4), VAL(4)
      DO 2560 I = 1, 4
        TABLE(I) = VAL(I)
2560  CONTINUE
      RETURN
      END
C ARCHIVE SYN2.RAT                24  30-NOV-81 14:32:16
C syn2 - report Ratfiv syntax error
      SUBROUTINE SYN2(MSG, F)
      INTEGER LC(7), MSG(*)
C Modif NB
      INTEGER CC
      INTEGER ITOC
      INTEGER I, JUNK, F
C-----------------------------------------------------------------------
C preprocessor common block to hold info about lines and included files
C put on a file named 'cline'
C used by ratfiv preproccessor and macro
      COMMON/CLINE/LEVEL, INFILE(4), LINECT(4), FNAMP(4), FNAMES(920), I
     *OIN(134)
C level of file inclusion; init = 1
      INTEGER LEVEL
C file number(level); init infile(1) = STDIN
      INTEGER INFILE
C line count on input file(level); init = 1
      INTEGER LINECT
C next free slot in fnames
      INTEGER FNAMP
C stack of open file names
      INTEGER FNAMES
C input buffer
      INTEGER IOIN
      INTEGER SERROR(17)
      INTEGER IN(5)
      DATA SERROR(1)/63/,SERROR(2)/32/,SERROR(3)/101/,SERROR(4)/114/,SER
     *ROR(5)/114/,SERROR(6)/111/,SERROR(7)/114/,SERROR(8)/32/,SERROR(9)/
     *97/,SERROR(10)/116/,SERROR(11)/32/,SERROR(12)/108/,SERROR(13)/105/
     *,SERROR(14)/110/,SERROR(15)/101/,SERROR(16)/32/,SERROR(17)/0/
      DATA IN(1)/32/,IN(2)/105/,IN(3)/110/,IN(4)/32/,IN(5)/0/
      CALL PUTLIN(SERROR, F)
      IF (LEVEL .GE. 1) THEN
        I = LEVEL
      ELSE
C for EOF errors
        I = 1
      END IF
      JUNK = ITOC(LINECT(I), LC, 7)
      CALL PUTLIN(LC, F)
      CALL PUTLIN(IN, F)
      CALL PUTLIN(FNAMES(FNAMP(I)), F)
      CC = 58
      CALL PUTCH(CC, F)
      CC = 32
      CALL PUTCH(CC, F)
      CALL PUTLIN(MSG, F)
      CC = 10
      CALL PUTCH(CC, F)
      RETURN
      END
C ARCHIVE SYNERR.RAT              13  30-NOV-81 14:32:16
C synerr - report ratfiv syntax error
      SUBROUTINE SYNERR(MSGCHAR)
      INTEGER MSG(134)
C Modif
      CHARACTER MSGCHAR*(*)
C cerrbf - holds an error message for later output by synerr
      COMMON/CERRBF/ERRBUF(201)
      INTEGER ERRBUF
      DO 2580 I = 1, LEN(MSGCHAR)
        MSG(I) = ICHAR(MSGCHAR(I:I))
2580  CONTINUE
      MSG(I + 1) = 0
      CALL XITSTA(3)
      CALL PUTLIN(ERRBUF, 0)
      CALL SYN2(MSG, 0)
      CALL PUTLIN(ERRBUF, 6)
      CALL SYN2(MSG, 6)
      ERRBUF(1) = 0
      RETURN
      END
C ARCHIVE UNDEF.RAT               33  30-NOV-81 14:32:16
C undef - undefine a macro and garbage collect
      SUBROUTINE UNDEF(NAME)
      INTEGER NAME(201), C
      INTEGER I, J, K, KNEXT, L, DEFLEN, LOCDEF, LENGTH, GETINT
C--------------------------------------------------------------------
C# preprocessor common block to hold definitions
C put on a file named 'clook'
C Used by ratfiv preprocessor, macro, and form tools
      COMMON/CLOOK/AVAIL, TABPTR(127), TABLE(10001)
Cfirst location in table; init = 1
      INTEGER AVAIL
Cname poiners; init = 0
      INTEGER TABPTR
Cactual text of names and definitions
      INTEGER TABLE
      IF (LOCDEF(NAME, I, J, C) .EQ. 1) THEN
        IF (TABPTR(C) .EQ. I) THEN
          TABPTR(C) = GETINT(TABLE(I))
        ELSE
          K = TABPTR(C)
          DO WHILE (GETINT(TABLE(K)) .NE. I)
2610        K = GETINT(TABLE(K))
          END DO
          CALL SETINT(TABLE(K), GETINT(TABLE(I)))
        END IF
        J = J + LENGTH(TABLE(J)) + 1
        DEFLEN = J - I
        DO 2630 L = 1, 127
          IF (TABPTR(L) .GT. I) THEN
            K = TABPTR(L)
            TABPTR(L) = TABPTR(L) - DEFLEN
            DO WHILE (GETINT(TABLE(K)) .GT. I)
              KNEXT = GETINT(TABLE(K))
              CALL SETINT(TABLE(K), KNEXT - DEFLEN)
2660          K = KNEXT
            END DO
          END IF
2630    CONTINUE
        DO WHILE (J .LT. AVAIL)
          TABLE(I) = TABLE(J)
          I = I + 1
2690      J = J + 1
        END DO
        AVAIL = I
      END IF
      RETURN
      END
